<?php
define('IMWB_VIDEOPRESS_VERSION', '3.9');
define('IMWB_VIDEOPRESS_WIZZARD_STEPS', 8);
define('MIN_MODE', '.min');
//define('MIN_MODE', '');

require_once ( get_template_directory() . '/theme-options.php' );
require_once ( get_template_directory() . '/theme-ads.php' );
require_once ( get_template_directory() . '/video-sitemap.php' );
require_once ( get_template_directory() . '/csscolor.php' );
require_once ( get_template_directory() . '/widgets.php');

add_action("after_setup_theme", "imwb_videopress_setup");
add_action("widgets_init", "imwb_videopress_widgets_init");
add_action('wp_head','imwb_videopress_head',50);
add_action('wp_footer', 'imwb_videopress_footer', 50 );
add_filter('imwb_videopress_filter_content', 'imwb_videopress_content_filter', 10, 2);
add_filter('excerpt_more', 'imwb_videopress_excerpt_more');
add_filter('excerpt_length', 'imwb_videopress_excerpt_length');

if (!is_admin()) {
   $imwb_videopress_swfobject = "";
   add_action('wp_enqueue_scripts', 'imwb_videopress_enqueue_scripts');
   add_action('pre_get_posts', 'imwb_videopress_posts_query' );
   add_filter('get_meta_sql', 'imwb_videopress_meta_sql');
 	add_action('wp_head', 'imwb_videopress_load_lc_script');
}
else {
  	add_action('wp_ajax_imwb_videopress_clear_lc_cookie', 'imwb_videopress_clear_lc_cookie');
   add_action('wp_ajax_rating', 'imwb_videopress_update_rating' );
   add_action('wp_ajax_nopriv_rating', 'imwb_videopress_update_rating' );
   add_action('wp_ajax_update_ctr_action', 'imwb_videopress_update_ctr' );
   add_action('wp_ajax_nopriv_update_ctr_action', 'imwb_videopress_update_ctr' );
   add_filter('manage_posts_columns', 'imwb_videopress_manage_post_add_column');
   add_action('manage_posts_custom_column', 'imwb_videopress_manage_post_show_column', 5, 2);
   add_action('admin_notices', 'imwb_videopress_admin_add_post_notice');
   add_action('admin_head', 'imwb_videopress_admin_head');

   require_once('imwb-theme-update-checker-no-lic.php');
   $ThemeUpdateChecker = new ImwbThemeUpdateChecker_nolic('5234538F29CBE', 'covertvideopress', 'theme-update', true);
}

function imwb_videopress_admin_add_post_notice() {
   global $wp_version;
   $screen = get_current_screen();
   if($screen->id != "post") return;
   if ( version_compare( $wp_version, '5.0', '>=' ) ) {
    return;
   }

   echo '<div class="cpp-edit-help">';
   _e( '<br>Here you can add posts to your blog just like you would do in any other Word Press theme. Note that Covert VideoPress is a video based theme and therfore your posts will either have a video or a featured image set.<br><br>Please watch the tutorial video for more information<br><br>', 'imwb_videopress' );
   echo '<div class="wizzard-watch-vid"><a href="'.(is_ssl() ? 'https' : 'http').'://youtube.com/embed/BtUjRF3NpPw" title="'.__( 'Click To Watch A Tutorial Video', 'imwb_videopress' ).'"><img src="'.get_template_directory_uri().'/images/wizard-watch-vid.png"></a></div>';
   echo '<a href="" class="close-btn">Close Help</a>';
   echo '</div>';
}

function imwb_videopress_admin_head() {
   global $wp_version;
   $screen = get_current_screen();
	 if($screen->id != "post") return;
   if ( version_compare( $wp_version, '5.0', '>=' ) ) {
    return;
   }
   wp_enqueue_style('jquery-style', 'http://code.jquery.com/ui/1.10.3/themes/redmond/jquery-ui.css');
   wp_enqueue_style('imwb_videopress-theme-edit-post-style', get_template_directory_uri().'/admin_edit_post.css');
   wp_enqueue_script("jquery-ui-dialog");
	wp_enqueue_script( 'imwb_videopress-theme-options-videopopup-script', get_template_directory_uri().'/scripts/jquery.videopopup.min.js', array('jquery'));
	$url = get_bloginfo('template_directory') . '/scripts/admin_edit_post'.MIN_MODE.'.js';
	echo '<script type="text/javascript" src="'. $url . '"></script>';
}

function imwb_videopress_get_blogtitle() {
	wp_title("|", true, "right");
	bloginfo("name");
}

function imwb_videopress_setup() {

   add_theme_support("automatic-feed-links");
   add_theme_support("post-thumbnails");
   set_post_thumbnail_size( 200, 150, true );

   $bgDefaults = array(
   	'default-color' => 'FFFFFF',
   	'default-image' => get_template_directory_uri() . '/images/background.png'
   );

   $headerDefaults = array(
   	'default-image'          => get_template_directory_uri().'/images/site-logo.png',
   	'random-default'         => false,
   	'width'                  => 400,
   	'height'                 => 50,
      'flex-height'            => false,
      'flex-width'             => false,
   	'default-text-color'     => 'blank',
   	'uploads'                => true,
   	'admin-head-callback'    => 'imwb_videopress_admin_header_style',
   	'admin-preview-callback' => 'imwb_videopress_admin_header_image',
   	'wp-head-callback'       => 'imwb_videopress_custom_background_callback'
   );


 	add_theme_support( 'custom-background', $bgDefaults);
 	add_theme_support( 'custom-header', $headerDefaults);

	add_image_size( 'imwb-videopress-video-thumb', 200, 150 );
	add_image_size( 'imwb-videopress-video-preview', 600, 400 );

	// This theme uses wp_nav_menu() in one location.
	register_nav_menu( 'cvp_page_menu', 'CVP Header Menu' );

}

function imwb_videopress_enqueue_styles() {
   wp_enqueue_style( 'bootstrap', get_template_directory_uri() . '/css/bootstrap'.MIN_MODE.'.css', false, IMWB_VIDEOPRESS_VERSION);
   wp_enqueue_style( 'theme-style', get_bloginfo( 'stylesheet_url' ), array('bootstrap'), IMWB_VIDEOPRESS_VERSION);
   wp_enqueue_style( 'jrating-style', get_template_directory_uri() . '/css/jRating'.MIN_MODE.'.css', array('bootstrap', 'theme-style'), IMWB_VIDEOPRESS_VERSION);
}

function imwb_videopress_enqueue_scripts() {
   imwb_videopress_enqueue_styles();

	wp_enqueue_script( 'swfobject' );
	wp_enqueue_script( 'jquery' );
	wp_enqueue_script( 'jquery_masonry', get_template_directory_uri() .'/scripts/masonry.pkgd'.MIN_MODE.'.js', array('jquery') );
	wp_enqueue_script( 'contentcarousel', get_template_directory_uri() . '/scripts/jquery.contentcarousel'.MIN_MODE.'.js', array( 'jquery' ));
  	wp_enqueue_script( 'simplemodal', get_template_directory_uri() . '/scripts/jquery.simplemodal.1.4.4'.MIN_MODE.'.js', array( 'jquery' ), '1.4.4');

	wp_localize_script('simplemodal', 'SimpleModalLeadCaptureL10n', array("empty_email" => __("The email field is empty.", 'imwb_videopress' ), "empty_all" => __("All fields are required.", 'imwb_videopress' ), "empty_firstname" => __("The first name field is empty.", 'imwb_videopress' ), "empty_lastname" => __("The last name field is empty.", 'imwb_videopress' )));

	wp_localize_script('jquery_masonry', 'IMWB_VIDEOPRESS', array("masnoryCW" => imwb_videopress_get_option('homesidebar') == '2' ? 242 : 2));


}

function imwb_videopress_excerpt_length($length) {
   if((is_home() || is_search() || is_category() || is_archive()) && imwb_videopress_get_option('postcontent') == 'C')
      return imwb_videopress_get_option('postchars');

   return $length;
}

function imwb_videopress_excerpt_more($more) {
   global $post;
   if(is_single())
      return '';

	return ' <a class="moretag cvp-ctr-track" data-post-item="'.get_the_ID().'" href="'.get_permalink().'">'.imwb_videopress_get_option('postmoretext').'</a>';
}

class imwb_videopress_walker_cat extends Walker_Category {
   var $cat_count = 0;
   var $col_count = 1;
   var $start_col = false;

	function start_el( &$output, $category, $depth = 0, $args = array(), $id = 0 ) {
		extract($args);

		$cat_name = esc_attr( $category->name );
		$cat_name = apply_filters( 'list_cats', $cat_name, $category );
		$link = '<a href="' . esc_url( get_term_link($category) ) . '" ';
		if ( $use_desc_for_title == 0 || empty($category->description) )
			$link .= 'title="' . esc_attr( sprintf(__( 'View all posts filed under %s', 'imwb_videopress' ), $cat_name) ) . '"';
		else
			$link .= 'title="' . esc_attr( strip_tags( apply_filters( 'category_description', $category->description, $category ) ) ) . '"';
		$link .= '>';
		$link .= $cat_name . '</a>';

		if ( !empty($feed_image) || !empty($feed) ) {
			$link .= ' ';

			if ( empty($feed_image) )
				$link .= '(';

			$link .= '<a href="' . esc_url( get_term_feed_link( $category->term_id, $category->taxonomy, $feed_type ) ) . '"';

			if ( empty($feed) ) {
				$alt = ' alt="' . sprintf(__( 'Feed for all posts filed under %s', 'imwb_videopress' ), $cat_name ) . '"';
			} else {
				$title = ' title="' . $feed . '"';
				$alt = ' alt="' . $feed . '"';
				$name = $feed;
				$link .= $title;
			}

			$link .= '>';

			if ( empty($feed_image) )
				$link .= $name;
			else
				$link .= "<img src='$feed_image'$alt$title" . ' />';

			$link .= '</a>';

			if ( empty($feed_image) )
				$link .= ')';
		}

		if ( !empty($show_count) )
			$link .= ' (' . intval($category->count) . ')';

		if ( 'list' == $args['style'] ) {
		   if($category->category_parent == '0')
   		   $this->cat_count++;

   		if($this->start_col) {
      		$output .= "</ul><ul class='reset'>";
      		$this->start_col = false;
      	}
			$output .= "\t<li";
			$class = 'cat-item cat-item-' . $category->term_id;
			if ( !empty($current_category) ) {
				$_current_category = get_term( $current_category, $category->taxonomy );
				if ( $category->term_id == $current_category )
					$class .=  ' current-cat';
				elseif ( $category->term_id == $_current_category->parent )
					$class .=  ' current-cat-parent';
			}
			if($args['has_children'])
			   $class .=  ' has_children';

			if($category->category_parent == '0') {
            $col_num = intval($this->cat_count / 20)+1;
			   if($col_num > $this->col_count) {
   			   $this->col_count++;
         		$this->start_col = true;
			   }
         }
			$output .=  ' class="' . $class . '"';
			$output .= ">$link\n";
		} else {
			$output .= "\t$link<br />\n";
		}
	}

}

function imwb_wp_list_categories($args) {

	$exclude = imwb_videopress_get_option('excludecats');
   $catList =  wp_list_categories(array_merge($args, array('echo'=> 0, 'exclude'=> $exclude, 'walker' => new imwb_videopress_walker_cat())));

   echo $catList;
}

function imwb_videopress_get_option($element) {

   $defaults = imwb_videopress_get_default_theme_options();

	$imwb_videopress_current_options = get_option('imwb_videopress_theme_options', $defaults);

	if(isset($imwb_videopress_current_options[$element]) && $imwb_videopress_current_options[$element] == '#')
		return stripslashes($defaults[$element]);
   else if(isset($imwb_videopress_current_options[$element]))
		return stripslashes($imwb_videopress_current_options[$element]);
	else if ( isset($defaults[$element]) )
		return stripslashes($defaults[$element]);
	else
		return false;
}

function imwb_videopress_update_option($element, $value) {

	$defaults = imwb_videopress_get_default_theme_options();
	$imwb_videopress_current_options = get_option('imwb_videopress_theme_options', $defaults);

	$imwb_videopress_current_options[$element] = $value;

   update_option('imwb_videopress_theme_options', $imwb_videopress_current_options);

}


function imwb_videopress_widgets_init() {

	register_sidebar(array(
		 "name"			=> "Main Sidebar"
		,"id"			=> "sidebar-widget"
		,"before_widget"=> '<li id="%1$s" class="widget-container %2$s">'
		,"after_widget"	=> "</li>"
		,"before_title"	=> "<h3 class=\"widget-title\">"
		,"after_title"	=> "</h3>"
	));

	register_sidebar(array(
		 "name"			=> "Single Post Sidebar"
		,"id"			=> "sidebar-post-widget"
		,"description" => "An optional widget area for your signle post page"
		,"before_widget"=> '<li id="%1$s" class="widget-container %2$s">'
		,"after_widget"	=> "</li>"
		,"before_title"	=> "<h3 class=\"widget-title\">"
		,"after_title"	=> "</h3>"
	));

	register_sidebar( array(
		 "name" => "Footer Area One"
		,"id" => "sidebar-footer-1"
		,"description" => "An optional widget area for your site footer"
      ,"before_widget"=> '<li id="%1$s" class="widget-container %2$s">'
      ,"after_widget"	=> "</li>"
      ,"before_title"	=> "<h3 class=\"widget-title\">"
      ,"after_title"	=> "</h3>"
	) );

	register_sidebar( array(
   	 "name" => "Footer Area Two"
   	,"id" => "sidebar-footer-2"
   	,"description" => "An optional widget area for your site footer"
      ,"before_widget"=> '<li id="%1$s" class="widget-container %2$s">'
      ,"after_widget"	=> "</li>"
      ,"before_title"	=> "<h3 class=\"widget-title\">"
      ,"after_title"	=> "</h3>"
   ) );

	register_sidebar( array(
   	 "name" => "Footer Area Three"
   	,"id" => "sidebar-footer-3"
   	,"description" => "An optional widget area for your site footer"
      ,"before_widget"=> '<li id="%1$s" class="widget-container %2$s">'
      ,"after_widget"	=> "</li>"
      ,"before_title"	=> "<h3 class=\"widget-title\">"
      ,"after_title"	=> "</h3>"
   ) );

   $active_widgets = get_option( 'sidebars_widgets' );

	if (!empty( $active_widgets['nag-bar-widget']))
	      return;

   // Note that widgets are numbered. We need a counter:
   $counter = 1;
   // Add a 'demo' widget to the top sidebar …
   $active_widgets['nag-bar-widget'][0] = 'text-' . $counter;
   $widget_content[ $counter ] = array ( 'title' => '', 'text' => '<p>This is a widget area - If you go to "Appearance" in your WP-Admin you can change the content of this box in "Widgets", or you can remove this box completely under "Theme Options"</p>' );

   update_option( 'widget_text', $widget_content );

   // Now save the $active_widgets array.
   update_option( 'sidebars_widgets', $active_widgets );
}

/**
 * Count the number of footer sidebars to enable dynamic classes for the footer
 */
function imwb_videopress_footer_sidebar_class() {
	$count = 0;

	if ( is_active_sidebar( 'sidebar-footer-1' ) )
		$count++;

	if ( is_active_sidebar( 'sidebar-footer-2' ) )
		$count++;

	if ( is_active_sidebar( 'sidebar-footer-3' ) )
		$count++;

	$class = '';

	switch ( $count ) {
		case '1':
			$class = 'one';
			break;
		case '2':
			$class = 'two';
			break;
		case '3':
			$class = 'three';
			break;
	}

	if ( $class )
		echo 'class="' . $class . '"';
}

function imwb_videopress_content_filter($content, $postImageSrc)
{
    if($postImageSrc == '')
	    $content = preg_replace('#(<[/]?img.*>)#U', '', $content);
    else
       $content = preg_replace('#<\s*img.+src=["\']'.preg_quote($postImageSrc).'["\'].*>#Ui', '', $content);

    return $content;
}

function imwb_videopress_strip_embed_code($text) {
    $tags = array('iframe','object','embed','param');
    foreach ($tags as $tag){
        while(preg_match('/<'.$tag.'(|\W[^>]*)>(.*)<\/'. $tag .'>/iusU', $text, $found)){
            $text = str_replace($found[0],$found[2],$text);
        }
    }

    $text =  preg_replace('/(<('.join('|',$tags).')(|\W.*)\/>)/iusU', '', $text);

    return $text;
}

function imwb_videopress_strip_video_shortcodes($text) {
	$tags = array('evp', 'youtube','dailymotion','vimeo','metacafe');

   foreach ($tags as $tag){
      $text =  preg_replace('/\['.$tag.'(|\W.*)\](.*)\[\/'. $tag .'\]/iusU', '', $text);
   }

   return $text;
}

/**
* Works out the default video lost order and returns it
*/
function imwb_videopress_list_order() {

 $option = isset($_REQUEST['so']) ? $_REQUEST['so'] : 'def';

 // Use option settings is not already set
 if($option == 'def') {

    switch(imwb_videopress_get_option('listorder')) {
       case '0': $option = 'rav';
                 break;
       case '1': $option = 'trv';
                 break;
       case '2': $option = 'mvv';
                 break;
       case '3': $option = 'tdv';
                 break;
    }
 }

 return $option;
}

/**
* Alters the main home page query to sort by Most Rated/Viewed if selected
*/
function imwb_videopress_posts_query($query) {

 if( $query->is_main_query() && is_home()) {

    $option = imwb_videopress_list_order();

    switch ( strtolower($option) ) {
       case 'mvv': $query->set( 'orderby', 'meta_value_num' );
                   $query->set( 'meta_key', '_imwb_videopress_post_video_views' );
     	             $query->set( 'order', 'DESC' );
     	             break;
       case 'trv': $query->set( 'orderby', 'meta_value_num' );
                   $query->set( 'meta_key', '_imwb_videopress_post_video_rating' );
      	          $query->set( 'order', 'DESC' );
      	          break;
      case 'tdv': $query->set( 'orderby', 'meta_value_num' );
                  $query->set( 'meta_key', '_imwb_videopress_post_video_ctr' );
      	         $query->set( 'order', 'DESC' );
      	         break;
   }
 }
}

/**
* Post List, Meta Data Box and Custom fields
*
*/

function imwb_videopress_manage_post_add_column( $columns ) {
   	return array_merge( $columns,
   	              array('imp' => __('Imps', 'imwb_videopress'),
   	                    'clicks' => __('Clicks', 'imwb_videopress'),
   	                    'ctr' => __('CTR %', 'imwb_videopress')) );
}

function imwb_videopress_manage_post_show_column( $column, $post_id) {

   switch ( $column ) {
      case 'imp':
	   case 'clicks':
      case 'ctr':
                $imp = get_post_meta( $post_id, '_imwb_videopress_post_video_imp', true );
                $value = get_post_meta( $post_id, '_imwb_videopress_post_video_'.$column, true );
                break;
   }

   if(empty($imp) || $imp == 0)
      echo "";
   else if($column == 'ctr')
      echo number_format($value, 2);
   else
      echo $value;
}


add_action( 'load-post.php', 'imwb_videopress_meta_boxes_setup' );
add_action( 'load-post-new.php', 'imwb_videopress_meta_boxes_setup' );

function imwb_videopress_meta_boxes_setup() {

	   /* Add meta boxes on the 'add_meta_boxes' hook. */
	   add_action( 'add_meta_boxes', 'imwb_videopress_add_post_meta_boxes' );
	   add_action( 'save_post', 'imwb_videopress_save_post_video_meta' );
}

function imwb_videopress_add_post_meta_boxes() {

	add_meta_box(
		'imwb_videopress-post-video',			// Unique ID
		esc_html__( 'Video', 'imwb_videopress' ),		// Title
		'imwb_videopress_post_video_meta_box',		// Callback function
		'post',					// Admin page (or post type)
		'normal',					// Context
		'high'					// Priority
	);

}

if ( in_array( basename( $_SERVER['PHP_SELF'] ), array( 'post-new.php', 'post.php') ) ) {
  add_action( 'admin_head', 'imwb_videopress_meta_boxes_head' );
}

function imwb_videopress_meta_boxes_head() {
?>
 <style>

    .imwbvp_video_thumbnail {
       border: 1px solid #DFDFDF;
       width: 200px;
       float: right;
       top:  3px;
       right: 5px;
    }
    .imwbvp_video_thumbnail span {
       text-align: center;
       background-color: #E9E9E9;
       display: block;
       padding: 3px;
    }
     .imwbvp_video_thumbnail .image {
       width: 200px;
       height: 150px;
       text-align: center;
       font-weight: bold;
    }
     .imwbvp_video_thumbnail .image img { width: 100% }
 </style>
 <script>
 ( function( $ ) {

    $(document).ready(function() {
       $hints = Array();
       $hints['D'] = 'Please enter the URL where the video can be viewed. <b>E.G.</b> http://www.dailymotion.com/video/xi9v9h_slow-mo-of-giant-bubbles-on-stinson-beach-ca_tech';
       $hints['F'] = 'Please enter the URL to the video file. <b>E.G.</b> http://yoursite.com/video.mp4';
       $hints['M'] = 'Please enter the URL where the video can be viewed. <b>E.G.</b> http://www.metacafe.com/watch/8748970/the_amazing_spider_man/';
       $hints['V'] = 'Please enter the URL where the video can be viewed. <b>E.G.</b> http://vimeo.com/40132261';
       $hints['Y'] = 'Please enter the URL where the video can be viewed. <b>E.G.</b> http://www.youtube.com/watch?v=SqtXkv0jigQ';

       $('input[name="imwb_videopress_post_video-type"]').change(function() {
           $('#imwb_videopress_post_video-label').html($hints[$(this).val()]);
       });

       $('#imwb_videopress_post_video-label').html($hints[$('input[name="imwb_videopress_post_video-type"]:checked').val()])

    });

 } ) ( jQuery );
 </script>
<?php
}

function imwb_videopress_post_video_meta_box( $object, $box ) { ?>

	<?php wp_nonce_field( basename( __FILE__ ), 'imwb_videopress-post-video_nonce' );
   $videoType = get_post_meta( $object->ID, 'imwb_videopress_post_video_type', true );
   if(empty($videoType)) $videoType = 'F';
	 ?>
	 <?php if(imwb_videopress_get_option('autogenthumbs') == '1') { ?>
	   		<div class="imwbvp_video_thumbnail">
	   		 <span>Video Thumbnail</span>
	   		 <div class="image">
	 <?php
	   		    $img = imwb_videopress_get_the_post_thumbnail();
	   		    if(empty($img))
	   		       echo '<br>Thumbnail generation will be attempted on next save/update';
	   		    else
	             echo $img;
	 ?>
	   		 </div>
	   		</div>
	 <?php } ?>
	<p>
	   <input type="radio" name="imwb_videopress_post_video-type" id="imwb_videopress_post_video-type" value="F" <?php checked( $videoType, 'F' ); ?>> Video File&nbsp;&nbsp;
	   <input type="radio" name="imwb_videopress_post_video-type" id="imwb_videopress_post_video-type" value="Y" <?php checked( $videoType, 'Y' ); ?>> You Tube&nbsp;&nbsp;
	   <input type="radio" name="imwb_videopress_post_video-type" id="imwb_videopress_post_video-type" value="V" <?php checked( $videoType, 'V' ); ?>> Vimeo&nbsp;&nbsp;
	   <input type="radio" name="imwb_videopress_post_video-type" id="imwb_videopress_post_video-type" value="D" <?php checked( $videoType, 'D' ); ?>> DailyMotion&nbsp;&nbsp;
	   <input type="radio" name="imwb_videopress_post_video-type" id="imwb_videopress_post_video-type" value="M" <?php checked( $videoType, 'M' ); ?>> Metacafe
	   <br><br>
		<label id="imwb_videopress_post_video-label" for="imwb_videopress_post_video-url">Link URL:</label><br>
		<input type="text" name="imwb_videopress_post_video-url" id="imwb_videopress_post_video-url" value="<?php echo esc_attr( get_post_meta( $object->ID, 'imwb_videopress_post_video_url', true ) ); ?>" size="50" />
	</p>
	<p>
	<label id="imwb_videopress_post_video-label" for="imwb_videopress_post_video-views">View Count:</label>	<input type="text" name="imwb_videopress_post_video-views" id="imwb_videopress_post_video-views" value="<?php echo esc_attr( get_post_meta( $object->ID, '_imwb_videopress_post_video_views', true ) ); ?>" size="10" />
	<label id="imwb_videopress_post_video-label" for="imwb_videopress_post_video-rating">Rating (From 0 to 5):</label>	<input type="text" name="imwb_videopress_post_video-rating" id="imwb_videopress_post_video-rating" value="<?php echo esc_attr( imwb_videopress_get_rating($object->ID ) ); ?>" size="10" />
	</p>
	<p>
	<label for="imwb_videopress_post_video-imp"><?php _e('Impressions', 'imwb_videopress');?>:</label>	<input type="text" name="imwb_videopress_post_video-imp" id="imwb_videopress_post_video-imp" value="<?php echo esc_attr( get_post_meta( $object->ID, '_imwb_videopress_post_video_imp', true ) ); ?>" size="10" />
	   <label for="imwb_videopress_post_video-clicks"><?php _e('Clicks', 'imwb_videopress');?>:</label>	<input type="text" name="imwb_videopress_post_video-clicks" id="imwb_videopress_post_video-clicks" value="<?php echo esc_attr( get_post_meta( $object->ID, '_imwb_videopress_post_video_clicks', true ) ); ?>" size="10" />
	 </p>

	 		<div style="clear: both"></div>
<?php }

function imwb_videopress_save_post_video_meta($post_id) {

 // verify if this is an auto save routine.
 // If it is our form has not been submitted, so we dont want to do anything
 if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE )
     return;

	/* Verify the nonce before proceeding. */
	if ( !isset( $_POST['imwb_videopress-post-video_nonce'] ) || !wp_verify_nonce( $_POST['imwb_videopress-post-video_nonce'], basename( __FILE__ ) ) )
		return $post_id;

   // Check permissions
   if ( 'page' == $_POST['post_type'] )
         return;
   else
   {
     if ( !current_user_can( 'edit_post', $post_id ) )
         return;
   }

   if(wp_is_post_revision($post_id))
      return;

	$vtChanged = true;

	/* Get the posted data and sanitize it for use as an HTML class. */
	$vt_meta_value = ( isset( $_POST['imwb_videopress_post_video-type'] ) ?  $_POST['imwb_videopress_post_video-type'] : '' );

   /* Get the meta key. */
   $meta_key = 'imwb_videopress_post_video_type';

   /* Get the meta value of the custom field key. */
   $meta_value = get_post_meta( $post_id, $meta_key, true );

   /* If a new meta value was added and there was no previous value, add it. */
   if ( $vt_meta_value && '' == $meta_value )
   	add_post_meta( $post_id, $meta_key, $vt_meta_value, true );

   /* If the new meta value does not match the old value, update it. */
   elseif ( $vt_meta_value && $vt_meta_value != $meta_value )
   	update_post_meta( $post_id, $meta_key, $vt_meta_value );

   /* If there is no new meta value but an old value exists, delete it. */
   elseif ( '' == $vt_meta_value && $meta_value )
   	delete_post_meta( $post_id, $meta_key, $meta_value );

   /* Nothing changed */
   else
   	$vtChanged = false;

   	$vuChanged = true;

   /* Get the posted data and sanitize it for use as an HTML class. */
   $vu_meta_value = ( isset( $_POST['imwb_videopress_post_video-url'] ) ? $_POST['imwb_videopress_post_video-url'] : '' );

	/* Get the meta key. */
	$meta_key = 'imwb_videopress_post_video_url';

	/* Get the meta value of the custom field key. */
	$meta_value = get_post_meta( $post_id, $meta_key, true );

	/* If a new meta value was added and there was no previous value, add it. */
	if ( $vu_meta_value && '' == $meta_value )
		add_post_meta( $post_id, $meta_key, $vu_meta_value, true );

	/* If the new meta value does not match the old value, update it. */
	elseif ( $vu_meta_value && $vu_meta_value != $meta_value )
		update_post_meta( $post_id, $meta_key, $vu_meta_value );

	/* If there is no new meta value but an old value exists, delete it. */
	elseif ( '' == $vu_meta_value && $meta_value )
		delete_post_meta( $post_id, $meta_key, $meta_value );

   /* Nothing changed */
   else
   	$vuChanged = false;

   /* Do we need to generate a thumbnail */
   if(($vtChanged || $vuChanged) && imwb_videopress_get_option('autogenthumbs') == '1')
         imwb_videopress_generate_thumbnail($post_id, $vt_meta_value, $vu_meta_value );

   /* Set the video id */
   if($vtChanged) { // If the video type changed then remove any existing id's
      delete_post_meta( $post_id , 'imwb_ctc_dailymotion_id');
      delete_post_meta( $post_id , 'imwb_ctc_metacafe_id');
      delete_post_meta( $post_id , 'imwb_ctc_youtube_id');
      delete_post_meta( $post_id , 'imwb_ctc_vimeo_id');
   }

   $video_id = imwb_videopress_get_video_id($vt_meta_value, $vu_meta_value);
   switch ( $vt_meta_value ) {
      case 'D': update_post_meta( $post_id , 'imwb_ctc_dailymotion_id', trim($video_id) );
                break;
      case 'M': update_post_meta( $post_id , 'imwb_ctc_metacafe_id', trim($video_id) );
    	          break;
   	case 'Y': update_post_meta( $post_id , 'imwb_ctc_youtube_id', trim($video_id) );
   		       break;
      case 'V': update_post_meta( $post_id , 'imwb_ctc_vimeo_id', trim($video_id) );
   		       break;
   }

   /* Views */
   $vc_meta_value = ( isset( $_POST['imwb_videopress_post_video-views'] ) ? $_POST['imwb_videopress_post_video-views'] : '0' );
   if(empty($vc_meta_value) || !is_numeric($vc_meta_value))
      $vc_meta_value = '0';

   if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_views', $vc_meta_value ) )
      add_post_meta( $post_id, '_imwb_videopress_post_video_views', $vc_meta_value, true );

   /* Rating */
   $vr_meta_value = ( isset( $_POST['imwb_videopress_post_video-rating'] ) ? $_POST['imwb_videopress_post_video-rating'] : '0' );
   if(empty($vr_meta_value) || !is_numeric($vr_meta_value))
      $vr_meta_value = '0';

   if($vr_meta_value < 0 || $vr_meta_value > 5)
      $vr_meta_value = '0';

   // * get current rating
   $rating_value = imwb_videopress_get_rating($post_id);

   // If Changed then reset */
   if($vr_meta_value != $rating_value) {

      if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_score', $vr_meta_value ) )
         add_post_meta( $post_id, '_imwb_videopress_post_video_score', $vr_meta_value, true );

      if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_count', '1' ) )
            add_post_meta( $post_id, '_imwb_videopress_post_video_count', '1', true );

      if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_rating', $vr_meta_value ) )
            add_post_meta( $post_id, '_imwb_videopress_post_video_rating', $vr_meta_value, true );
   }

   /* Impressions */
   $vc_imp_value = ( isset( $_POST['imwb_videopress_post_video-imp'] ) ? $_POST['imwb_videopress_post_video-imp'] : '0' );
   if(empty($vc_imp_value) || !is_numeric($vc_imp_value))
      $vc_imp_value = '0';

   if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_imp', $vc_imp_value ) )
      add_post_meta( $post_id, '_imwb_videopress_post_video_imp', $vc_imp_value, true );

   /* Clicks */
   $vc_clicks_value = ( isset( $_POST['imwb_videopress_post_video-clicks'] ) ? $_POST['imwb_videopress_post_video-clicks'] : '0' );
   if(empty($vc_clicks_value) || !is_numeric($vc_clicks_value))
      $vc_clicks_value = '0';

   if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_clicks', $vc_clicks_value ) )
      add_post_meta( $post_id, '_imwb_videopress_post_video_clicks', $vc_clicks_value, true );

   if(!empty($vc_imp_value))
      $ctr = ($vc_clicks_value / $vc_imp_value)*100;
   else
      $ctr = 0;

   if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_ctr', $ctr ) )
      add_post_meta( $post_id, '_imwb_videopress_post_video_ctr', $ctr, true );

}

function imwb_videopress_custom_background_callback(){

   /* Get the background image. */
   $image = get_background_image();

   /* If there's an image, just call the normal WordPress callback. We won't do anything here. */
   if ( !empty( $image ) ) {
   	_custom_background_cb();
   	return;
   }

   /* Get the background color. */
   $color = get_background_color();

   /* Use 'background' instead of 'background-color'. */
   $style = "background: #{$color};";

   ?>
   <style type="text/css">body { <?php echo trim( $style ); ?> }</style>
   <?php

}

/**
* Preview and Styles the header image displayed on the Appearance > Header admin panel.
*
*/
function imwb_videopress_admin_header_image() { 	?>
	<div id="headimg" style="background: url(<?php header_image(); ?>) no-repeat scroll top;">
		<?php $style = ' style="color:#' . get_header_textcolor() . ';"'; ?>
		<div class="hgroup">
			<h1 id="name"<?php echo $style; ?>><?php bloginfo( 'name' ); ?></h1>
			<h2 id="desc"<?php echo $style; ?>><?php bloginfo( 'description' ); ?></h2>
		</div>
	</div>
<?php }

function imwb_videopress_admin_header_style() {
	$header_image = get_header_image();
?>
	<style type="text/css">
	.appearance_page_custom-header #headimg {
		border: none;
		-webkit-box-sizing: border-box;
		-moz-box-sizing:    border-box;
		box-sizing:         border-box;
		<?php
		if ( ! empty( $header_image ) ) {
			echo 'background: url(' . esc_url( $header_image ) . ') no-repeat scroll top;';
		} ?>
		padding: 0;
		width: 400px;
		height: 50px;
	}
	#headimg .hgroup {
  	 font-family: "Helvetica Neue",Helvetica,Arial,sans-serif;
		-webkit-box-sizing: border-box;
		-moz-box-sizing:    border-box;
		box-sizing:         border-box;
		width: 400px;
   height: 50px;
	}
	<?php if ( ! display_header_text() ) : ?>
	#headimg h1,
	#headimg h2 {
		position: absolute !important;
		clip: rect(1px 1px 1px 1px); /* IE7 */
		clip: rect(1px, 1px, 1px, 1px);
	}
	<?php endif; ?>
	#headimg h1 {font-size: 1.75em; margin: 0;font-weight: bold;line-height: 1.231em;padding: 0;}
	#headimg h1 a {text-decoration: none;}
	#headimg h1 a:hover {text-decoration: underline;}
	#headimg h2 {font-weight: 400;font-size: 1em; margin: 0;line-height: 1.2em;padding: 0;}
	.default-header img {width: 400px;}
	</style>
<?php
}

function imwb_videopress_head() {

  imwb_videopress_open_graph_head();
?>
<script type="text/javascript">
// <![CDATA[
	var imwbvp_flashvars = {};
//	var imwbvp_params = { wmode: "opaque", allowfullscreen: "true", allowscriptaccess: "always", allownetworking: "internal" };
	var imwbvp_params = { wmode: "opaque", allowfullscreen: "true", allowscriptaccess: "always"};
	var imwbvp_attributes = {};
	var imwbvp_expressinstall = "<?php echo get_template_directory_uri(); ?>/assets/expressinstall.swf";
	var imwbvp_ajaxurl = '<?php echo admin_url( 'admin-ajax.php' );?>';
// ]]>
</script>
<?php
}

function imwb_videopress_footer() {
   global $imwb_videopress_swfobject;

   if ( is_feed() || empty($imwb_videopress_swfobject) )
      return;

	$content = "\n<script type=\"text/javascript\">\n";

	$content .= '	swfobject.embedSWF("' . ( $imwb_videopress_swfobject['url'] ) . '", "' . $imwb_videopress_swfobject['objectid'] . '", "600", "400", "10", imwbvp_expressinstall, ';

		if ( empty($imwb_videopress_swfobject['flashvars']) || !is_array($imwb_videopress_swfobject['flashvars']) ) {
			$content .= 'imwbvp_flashvars';
		} else {
			$content .= '{ ';

			//$imwb_videopress_swfobject['flashvars'] = array_merge( array( 'wmode' => 'opaque', 'allowfullscreen' => 'true', 'allowscriptaccess' => 'always' ), $imwb_videopress_swfobject['flashvars'] );
			$flashvars = array();

			foreach ( $imwb_videopress_swfobject['flashvars'] as $property => $value ) {
				if ( false === $value )
					continue;

				$flashvars[] = '"' . esc_js( $property ). '": "' . esc_js( $value ) . '"';
			}

			$content .= implode( ', ', $flashvars );
			$content .= ' }';
		}

		$content .= ", imwbvp_params, imwbvp_attributes);\n";
	$content .= "</script>\n";

	// Clear outputted calls
	$imwb_videopress_swfobject = "";

	echo $content;
}

// build ogp meta
function imwb_videopress_open_graph_head() {

  	global $post;

	echo "\n<!-- Open Graph protocol meta data -->\n";

	// Which URL we need
	if (is_home() || is_front_page() || is_search() || is_category() )
		$ogp_url = get_bloginfo( 'url' );
	else
		$ogp_url = 'http' . (is_ssl() ? 's' : '') . "://".$_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];

	echo '<meta property="og:url" content="' . esc_url($ogp_url) . '">' . "\n";

	// Site Title
	echo '<meta property="og:title" content="' . esc_attr( wp_title("|", false, "right").get_bloginfo( 'name' ) ) . '">' . "\n";

	//  Site Name
	echo '<meta property="og:site_name" content="' . get_bloginfo( 'name' ) . '">' . "\n";

	// Descriptions
	if ( is_single() || is_page() ) {
		if ( has_excerpt( $post->ID ) )
			$ogp_description = strip_tags( get_the_excerpt( $post->ID ) );
		else
			$ogp_description = str_replace( "\r\n", ' ' , substr( strip_tags( strip_shortcodes( $post->post_content ) ), 0, 160 ) );
	}
	else
		$ogp_description = get_bloginfo( 'description' );

	echo '<meta property="og:description" content="' . esc_attr( $ogp_description ). '">' . "\n";

	// OG Type
	if ( is_single() || is_page()) {
		$ogp_type = 'article';
	} else {
		$ogp_type = 'website';
	}
	echo '<meta property="og:type" content="' . esc_attr($ogp_type) . '">' . "\n";

	// Find/output any images for use in the OGP tags
	$wpfbogp_images = array();

	// Image details
   if ( is_single() || is_page()) {

  /* 	$postImage = imwb_videopress_get_the_image(Array('image_class' => 'tack_entry_img', "link_to_post" => false, 'echo' => false, 'size' => '', 'use_image_scan_link' => true));
	   preg_match_all( '|<img.*?src=[\'"](.*?)[\'"].*?>|i', $postImage, $matches );
   	$postImageSrc = $matches[1][0];
   */
   	 $postImageSrc = imwb_videopress_post_thumbnail_img_src();
		echo '<meta property="og:image" content="' . esc_url($postImageSrc) . '">' . "\n";
	}
	else
		// No images were outputted because they have no default image (at the very least)
		echo "<!-- Could not find an image! -->\n";

	// Locale
	echo '<meta property="og:locale" content="' . strtolower( esc_attr( get_locale() ) ) . '">' . "\n";
	echo "<!--  Open Graph protocol meta data  -->\n";

}

function imwb_videopress_the_video($post_id) {

   $video_type = get_post_meta( $post_id, 'imwb_videopress_post_video_type', true );
   $video_url = get_post_meta( $post_id, 'imwb_videopress_post_video_url', true );

   if(empty($video_url))
     return '';

   $the_video = '';

   switch ( $video_type ) {
   case 'D':
      $the_video =  imwb_videopress_video_dailymotion($video_url, $post_id);
      break;
   	case 'F':
   		$the_video =  imwb_videopress_video_file($video_url, $post_id);
   		break;
   case 'M':
   	$the_video =  imwb_videopress_video_metacafe($video_url, $post_id);
   	break;
   	case 'Y':
   		$the_video =  imwb_videopress_video_youtube($video_url, $post_id);
   		break;
   case 'V':
      $the_video =  imwb_videopress_video_vimeo($video_url, $post_id);
   		break;
   }

   return $the_video;
}

/*
 * Extract the ID from the video url
 */
function imwb_videopress_get_video_id($video_type, $video_url) {

   // YouTube
   if($video_type == 'Y') {
   	// If a URL was passed
   	if ( 'http://' == substr( $video_url, 0, 7 ) || 'https://' == substr( $video_url, 0, 8 )) {

      if ( FALSE !== stristr( $video_url, 'youtu.be' ) ) {
   		   preg_match( '#https?://youtu\.be/([\w-]+)#i', $video_url, $matches );
   			if ( empty($matches) || empty($matches[1]) )
   				return '';

         return $matches[1];
   		}
   		// Normal video URL
   		else {
   			preg_match( '#https?://(www.youtube|youtube|[A-Za-z]{2}.youtube)\.com/(watch\?v=|w/\?v=|\?v=)([\w-]+)(.*?)#i', $video_url, $matches );
   			if ( empty($matches) || empty($matches[3]) )
   			   return '';

   			return $matches[3];
   		}
   	}
   	// If a URL wasn't passed, assume a video ID
   	else {
   	   return $video_url;
   	}
   }
   // Vimeo
   elseif($video_type == 'V') {
   	// If a URL was passed
   	if ( 'http://' == substr( $video_url, 0, 7 ) ) {
   		preg_match( '#http://(www.vimeo|vimeo)\.com(/|/clip:)(\d+)(.*?)#i', $video_url, $matches );
   		if ( empty($matches) || empty($matches[3]) )
   		   return '';

   		return $matches[3];
   	}
   	// If a URL wasn't passed, assume a video ID
   	else {
   		return $video_url;
   	}
   }
   // DailyMotion
   elseif($video_type == 'D') {
   	if ( 'http://' == substr( $video_url, 0, 7 ) ) {
   		preg_match( '#http://(www.dailymotion|dailymotion)\.com/(.+)/([0-9a-zA-Z]+)\_(.*?)#i', $video_url, $matches );
   		if ( empty($matches) || empty($matches[3]) )
   		   return '';

   		return $matches[3];
   	}
      // If a URL wasn't passed, assume a video ID
   	else {
   		return $video_url;
   	}
   }
   // Metacafe
   elseif($video_type == 'M') {
   	// If a URL was passed
   	if ( 'http://' == substr( $video_url, 0, 7 ) ) {
   		preg_match( '#http://(www.metacafe|metacafe)\.com/watch/(.*?)/(.*?)#i', $video_url, $matches );
   		if ( empty($matches) || empty($matches[2]) )
   		   return '';

   		return $matches[2];
   	}
   	// If a URL wasn't passed, assume a video ID was passed instead
   	else {
   		return $video_url;
   	}
   }

   return '';
}

function imwb_videopress_video_file($video_url, $post_id) {

  $video_type = wp_check_filetype($video_url);

   // ID is required for multiple videos to work
  	$id = 'video_id_'.rand();

   // See what filetype Supplied
   $flv_source = '';
  	$mp4_source = '';
		$webm_source = '';
		$ogg_source = '';

   switch(strtolower($video_type['ext'])) {
      case 'flv':  $flv_source = '<source src="'.$video_url.'" type=\'video/flv\' />';
                   break;
      case 'mp4':
      case 'm4v':  $mp4_source = '<source src="'.$video_url.'" type=\'video/mp4\' />';
                   break;
      case 'webm': $webm_source = '<source src="'.$video_url.'" type=\'video/webm; codecs="vp8, vorbis"\' />';
                   break;
      case 'ogg':  $ogg_source = '<source src="'.$video_url.'" type=\'video/ogg; codecs="theora, vorbis"\' />';
                   break;
   }

   $poster_attribute = ' poster="'.esc_html__(imwb_videopress_post_thumbnail_img_src($post_id, 'imwb-videopress-video-preview')).'"';

   // Preload the video
   $preload_attribute = 'preload="auto"';

   // Autoplay the video?
   if (imwb_videopress_get_option('autoplay') == '1')
   	$autoplay_attribute = " autoplay";
   else
   	$autoplay_attribute = "";

   $videojs = <<<_end_

   <!-- Begin Video.js -->
   <video id="{$id}" class="video-js vjs-default-skin" width="600px" height="400px" {$poster_attribute} controls {$preload_attribute}{$autoplay_attribute} data-setup="{}">
      {$flv_source}
   	{$mp4_source}
   	{$webm_source}
   	{$ogg_source}
   </video>
   <!-- End Video.js -->

_end_;

   return $videojs;
}

function imwb_videopress_video_youtube($video_url, $post_id) {

   $video_id = imwb_videopress_get_video_id('Y', $video_url);

   // Setup the parameters
   $color1 = $color2 = $border = $autoplay = $loop = $showsearch = $showinfo = $hd = '';

   $color1 = '&color1=0x666666';
   $color2 = '&color2=0xEFEFEF';
   $border = '&border=1';
   $autoplay = '&autoplay='.imwb_videopress_get_option('autoplay');
   $hd = '&hd=1';
   $objectid = 'video_id_'.rand();
   $modestbranding = '&modestbranding='.imwb_videopress_get_option('ytmodestbrand');

   if (is_ssl()) $proto = 'https'; else $proto = 'http';

   return '<iframe class="youtube-player" type="text/html" width="100%" height="100%" src="'.$proto .'://www.youtube.com/embed/'.$video_id.'?rel=0&fs=1&showsearch=0&showinfo=0'.$autoplay.$hd.$border.$color1.$color2.$modestbranding.'" frameborder="0" webkitAllowFullScreen="true" mozallowfullscreen="true" allowFullScreen="true"></iframe>';
}

function imwb_videopress_video_vimeo($video_url, $post_id) {

    $video_id = imwb_videopress_get_video_id('V', $video_url);

    $objectid = 'video_id_'.rand();
    $autoplay = '&amp;autoplay='.imwb_videopress_get_option('autoplay');

    if (is_ssl()) $proto = 'https'; else $proto = 'http';

    return '<span style="width:100%;height:100%;"><iframe id="' . $objectid . '" src="'.$proto.'://player.vimeo.com/video/'.$video_id.'?title=0&amp;byline=0&amp;portrait=0&amp;color=f20511'.$autoplay.'" width="100%" height="100%" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe> </span>';

}

function imwb_videopress_video_dailymotion($video_url, $post_id) {

   $video_id = imwb_videopress_get_video_id('D', $video_url);
   $objectid = 'video_id_'.rand();

   $autoplay = '&autoPlay='.imwb_videopress_get_option('autoplay');

   if (is_ssl()) $proto = 'https'; else $proto = 'http';

   return '<iframe frameborder="0" width="100%" height="100%" src="'.$proto.'://www.dailymotion.com/embed/video/' . $video_id . '?logo=0&hideInfos=1'.$autoplay.'"></iframe>';
}

function imwb_videopress_video_metacafe($video_url, $post_id) {
   global $imwb_videopress_swfobject;

   $video_id = imwb_videopress_get_video_id('M', $video_url);
   $objectid = 'video_id_'.rand();
   $autoplay = imwb_videopress_get_option('autoplay') == '0' ? 'no' : 'yes';


   $imwb_videopress_swfobject = array( 'width' => '100%', 'height' => '100%', 'url' => 'http://www.metacafe.com/fplayer/' . $video_id . '/imwb_videopress_player.swf', 'flashvars' => array('playerVars=autoPlay' => $autoplay),
      'objectid' => $objectid  );

   return '<span style="width:100%;height:100%;"><span id="' . $objectid . '"><a href="http://www.metacafe.com/watch/' . $video_id . '/">http://www.metacafe.com/watch/' . $video_id . '/</a></span></span>';
}

/*
 * Thumbnail Functions
 */
function imwb_videopress_the_post_thumbnail ( $post_id = null, $width = '240px', $height = '160px' ) {
   echo imwb_videopress_get_the_post_thumbnail($post_id, $width, $height);
}

function imwb_videopress_get_the_post_thumbnail ( $post_id = null, $width = '240px', $height = '160px' ) {

   // Get the post ID if none is provided
   if ( $post_id == null OR $post_id == '' ) $post_id = get_the_ID();

   $image_src = imwb_videopress_post_thumbnail_img_src ( $post_id);

   if(empty($image_src))
      return '';

   $attr = apply_filters( 'the_title', get_post_field( 'post_title', $post_id ), $post_id );

   return sprintf('<img src="%s" width="%s" height="%s" title="%s" alt="%s">', $image_src, $width, $height,  $attr, $attr);
}

function imwb_videopress_post_thumbnail_img_src ( $post_id = null, $size = 'imwb-videopress-video-thumb' ) {

   // Get the post ID if none is provided
   if ( $post_id == null OR $post_id == '' ) $post_id = get_the_ID();

   // If featured image set, use that one
   if(has_post_thumbnail($post_id)) {
      $post_thumbnail_id = get_post_thumbnail_id( $post_id );
      $image_attributes =  wp_get_attachment_image_src($post_thumbnail_id, $size );
      return $image_attributes[0];
   }


   // If Thumbnail attached then use that one
   if( ( $thumbnail_meta = get_post_meta( $post_id, '_video_thumbnail', true ) ) != '' ) {
   	return $thumbnail_meta;
   }

   // Else use default image

   return  get_template_directory_uri() .'/images/default.jpg';

}

function imwb_videopress_generate_thumbnail($post_id, $video_type, $video_url) {

   // Remove any current thumbnail
  	delete_post_meta( $post_id, '_video_thumbnail' );

   if(empty($video_url)) return;

	$video_thumbnail = '';

   $video_id = imwb_videopress_get_video_id($video_type, $video_url);

   /* Video file */
   if($video_type == 'F')
      $video_thumbnail = ''; // Yeah one day

   /* YouTube Video */
   elseif ($video_type == 'Y')
      $video_thumbnail = 'http://img.youtube.com/vi/' . $video_id . '/0.jpg';

   /* Viemo Video */
   elseif ($video_type == 'V' ){

	   $response = wp_remote_get( 'http://vimeo.com/api/v2/video/' . $video_id . '.php' );

	   if( is_wp_error( $response ) ) {
	      $video_thumbnail = '';
	   } else {
         $output = unserialize( $response['body'] );
         $video_thumbnail = $output[0]['thumbnail_large'];
         if(!isset($video_thumbnail))
            $video_thumbnail = $output[0]['thumbnail_medium'];
	   }
   }

   /* DailyMotion Video */
   elseif ($video_type == 'D' ){

      $response = wp_remote_get( 'https://api.dailymotion.com/video/' . $video_id . '?fields=thumbnail_url' );
      if( is_wp_error( $response ) ) {
         $video_thumbnail = '';
      } else {
         $output = json_decode( $response['body']  );
         $video_thumbnail = strtok($output->thumbnail_url, '?');
      }
   }
   /* Metacafe Video */
   elseif ($video_type == 'M' ){

      $response = wp_remote_get('http://www.metacafe.com/api/item/' . $video_id . '/', array( 'sslverify' => false ));
      if( is_wp_error( $response ) ) {
         $video_thumbnail = '';
      } else {
        $xml = new SimpleXMLElement( $response['body'] );
        $result = $xml->xpath( "/rss/channel/item/media:thumbnail/@url" );
        $video_thumbnail = (string) $result[0]['url'];
      }
   }

   // See if need to store the image locally
   if(imwb_videopress_get_option('storethumbs') == '1' && !empty($video_thumbnail)) {

      $response = wp_remote_get($video_thumbnail);
      if( !is_wp_error( $response ) ) {
         $upload = wp_upload_bits( basename( $video_thumbnail ), null, $response['body'] );
         $video_thumbnail = $upload['url'];
      }

   }

   add_post_meta( $post_id, '_video_thumbnail', $video_thumbnail, true );

}

/*
* Page Numbers & Navigation Functions
*/
function imwb_videopress_page_numbers($range = 4) {
	global $wp_query;

	$big = 999999999; // This needs to be an unlikely integer
   $pages = $wp_query->max_num_pages;
   $paged = max( 1, get_query_var('paged'));

	// For more options and info view the docs for paginate_links()
	// http://codex.wordpress.org/Function_Reference/paginate_links
	$paginate_links = paginate_links( array(
		'base' => str_replace( $big, '%#%', get_pagenum_link($big) ),
		'current' => $paged,
		'total' => $pages,
		'mid_size' => 5
	) );

	// Display the pagination if more than one page is found
	if ( $paginate_links ) {
	   echo '<div id="pagination_wrapper">';
		echo '<div class="pagination"><span>Page '.$paged.' of '.$pages.'</span>';
		echo $paginate_links;
		echo '</div>';
		echo '</div>';
	}
}

/**
 * Display the language string for the number of views the current post has.
 *
 */
function imwb_videopress_views_number( $zero = false, $one = false, $more = false, $post_id = null) {

   // Get the post ID if none is provided
   if ( $post_id == null OR $post_id == '' ) $post_id = get_the_ID();

   $number = get_post_meta( $post_id, '_imwb_videopress_post_video_views', true );
   if(empty($number)) {
      $number = 0;
      add_post_meta( $post_id, '_imwb_videopress_post_video_views', $number, true );
   }

   if ( $number > 1 )
   	$output = str_replace('%', number_format_i18n($number), ( false === $more ) ? __('% Views') : $more);
   elseif ( $number == 0 )
   	$output = ( false === $zero ) ? __('No Views') : $zero;
   else // must be one
   	$output = ( false === $one ) ? __('1 View') : $one;

   echo $output;
}

function imwb_videopress_inc_views($post_id = null){
   // Get the post ID if none is provided
   if ( $post_id == null OR $post_id == '' ) $post_id = get_the_ID();

   $views = get_post_meta( $post_id, '_imwb_videopress_post_video_views', true );
   if(empty($views))
      $views = 1;
   else
      $views++;

   if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_views', $views ) )
    add_post_meta( $post_id, '_imwb_videopress_post_video_views', $views, true );
}

function imwb_videopress_update_imp($post_id = null) {

  // Get the post ID if none is provided
  if ( $post_id == null OR $post_id == '' ) $post_id = get_the_ID();

  $imp = get_post_meta( $post_id, '_imwb_videopress_post_video_imp', true );
  if(empty($imp) || !is_numeric($imp))
      $imp = 1;
  else
      $imp++;

  if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_imp', $imp ) )
       add_post_meta( $post_id, '_imwb_videopress_post_video_imp', $imp, true );

  $clicks = get_post_meta( $post_id, '_imwb_videopress_post_video_clicks', true );
  if(empty($clicks))
   $clicks = 0;

  $ctr = ($clicks / $imp)*100;

  if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_ctr', $ctr ) )
       add_post_meta( $post_id, '_imwb_videopress_post_video_ctr', $ctr, true );

  return true;
}

function imwb_videopress_get_rating($post_id = null) {
   // Get the post ID if none is provided
   if ( $post_id == null OR $post_id == '' ) $post_id = get_the_ID();

   $count = get_post_meta( $post_id, '_imwb_videopress_post_video_count', true );
   if(empty($count))
      $count = 1;

   $score = get_post_meta( $post_id, '_imwb_videopress_post_video_score', true );
   if(empty($score))
      $score = 0;

   $rating = get_post_meta( $post_id, '_imwb_videopress_post_video_rating', true );
   if(empty($rating)) {
      $rating = 0;
      add_post_meta( $post_id, '_imwb_videopress_post_video_rating', $rating, true );
   }

   $avgRating = round($score/$count, 0);

   if($avgRating <> $rating) {
      if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_rating', $avgRating ) )
         add_post_meta( $post_id, '_imwb_videopress_post_video_rating', $avgRating, true );
   }

   return $avgRating;
}

function imwb_videopress_lead_capture_email() {
   if (!session_id()){
   	session_start();
   }

   $errors = Array();

   $firstname = $_REQUEST['firstname'];
   $lastname = "";$_REQUEST['lastname'];
   $email = strtolower($_REQUEST['user_email']);

   // Do any AR Stuff
   if(imwb_videopress_get_option('leadcapturearoption') == 'G') { // Get Response
      require_once ( get_template_directory() . '/getresponse-api/jsonRPCClient.php' );
      $GR_client = new jsonRPCClient('http://api2.getresponse.com');
      try {
           $result = $GR_client->add_contact(imwb_videopress_get_option('getresponse_api_key'),
                           array ("campaign" =>  imwb_videopress_get_option('getresponse_campaign'),
                                  "name" => $firstname.' '.$lastname,
                                  "email" => $email,
                                  "cycle_day" =>'0',
                                  "ip" => $_SERVER['REMOTE_ADDR']
                            ));
        } catch (Exception $e) {
           //return '<div class="message">GetResponse API Error: '.$e->getMessage().'</div>';
        }

   }
   else if(imwb_videopress_get_option('leadcapturearoption') == 'A' && imwb_videopress_get_option('aweber_auth_code') != '' && imwb_videopress_get_option('aweber_consumer_key') != '') { // AWeber

         require_once ( get_template_directory() . '/aweber_api/aweber_api.php');

         $aweber = new AWeberAPI(imwb_videopress_get_option('aweber_consumer_key'), imwb_videopress_get_option('aweber_consumer_secret'));

         try {
             $account = $aweber->getAccount(imwb_videopress_get_option('aweber_access_key'), imwb_videopress_get_option('aweber_access_secret'));
             $subs = $account->loadFromUrl('/accounts/'.$account->id.'/lists/'.imwb_videopress_get_option('aweber_list'). '/subscribers');

             # create a subscriber
             $params = array(
                 'email' => $email,
                 'ip_address' => $_SERVER['REMOTE_ADDR'],
                 'ad_tracking' => 'covert shirt store',
                 'name' => $firstname.' '.$lastname
             );

             $new_subscriber = $subs->create($params);

         } catch(AWeberAPIException $exc) {
            return '<div class="message"><h3>AWeberAPIException:</h3><li> Type: '.$exc->type.'<br><li> Msg : '.$exc->message.'<br><li> Docs: '.$exc->documentation_url.'<br><hr>';
         }
   }
   else if(imwb_videopress_get_option('leadcapturearoption') == 'I' || imwb_videopress_get_option('leadcapturearoption') == 'M'
            || imwb_videopress_get_option('leadcapturearoption') == 'O') {

      $ar_data = get_option('imwb_videopress_theme_ar_data');

      foreach ($ar_data['form_data'] as $key => $value) {
   		if($value == "%%EMAIL%%") $ar_data['form_data'][$key] = urldecode($email);
   		if($value == "%%NAME%%") $ar_data['form_data'][$key] = urldecode($firstname.' '.$lastname);
   		if($value == "%%FNAME%%") $ar_data['form_data'][$key] = urldecode($firstname);
   		if($value == "%%LNAME%%") $ar_data['form_data'][$key] = urldecode($lastname);
   	}

   	$args = array('method' => 'POST','timeout' => 45,'redirection' => 5,'httpversion' => '1.0','blocking' => true,'headers' => array(),'body' => $ar_data['form_data'],'cookies' => array());
      $response = wp_remote_post($ar_data['action'],$args);
   }

   return '<div class="message">'.__('Signup Complete', 'imwb_videopress').'</div>';

}


/**
 * AJAX Callback functions
 */
function imwb_videopress_update_rating() {
   $post_id = intval($_POST['idBox']);
   $rate = floatval($_POST['rate']);

   $count = get_post_meta( $post_id, '_imwb_videopress_post_video_count', true );
   if(empty($count))
    $count = 0;

   $score = get_post_meta( $post_id, '_imwb_videopress_post_video_score', true );
   if(empty($score))
    $score = 0;

   $count++;
   $score+=$rate;

   if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_score', $score ) )
    add_post_meta( $post_id, '_imwb_videopress_post_video_score', $score, true );

   if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_count', $count ) )
       add_post_meta( $post_id, '_imwb_videopress_post_video_count', $count, true );

   $avgRating = round($score/$count, 0);

   if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_rating', $avgRating ) )
   add_post_meta( $post_id, '_imwb_videopress_post_video_rating', $avgRating, true );

   $aResponse['message'] = 'Your rate has been successfuly recorded. Thanks for your rate :)';

   echo json_encode($aResponse);
   die();
}

function imwb_videopress_clear_lc_cookie() {

	$nonce = $_POST['nonce'];
	$msnNum = $_POST['msnNum'];

   if ( ! wp_verify_nonce( $nonce, 'imwb_videopress_clear_cookie_nonce' ) )
      die ( 'Busted!');

	setcookie('imwb_videopress_E_show','Y',time()-8640000,COOKIEPATH);
	setcookie('imwb_videopress_F_show','Y',time()-8640000,COOKIEPATH);
	setcookie('imwb_videopress_P_show','Y',time()-8640000,COOKIEPATH);
	setcookie('imwb_videopress_T_show','Y',time()-8640000,COOKIEPATH);
	setcookie('imwb_videopress_W_show','Y',time()-8640000,COOKIEPATH);

	echo 'OK';

	die();
}

function imwb_videopress_update_ctr() {
   $post_id = intval($_POST['postid']);

   $nonce = $_POST['nonce'];

   // check to see if the submitted nonce matches with the
   // generated nonce we created earlier
   if ( ! wp_verify_nonce( $nonce, 'imwb_videopress_update_ctr' ) )
      die ( 'Busted!');

   $imp = get_post_meta( $post_id, '_imwb_videopress_post_video_imp', true );
   if(empty($imp) || !is_numeric($imp))
      $imp = 1;

   $clicks = get_post_meta( $post_id, '_imwb_videopress_post_video_clicks', true );
   if(empty($clicks))
      $clicks = 1;
   else
      $clicks++;

   if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_clicks', $clicks ) )
      add_post_meta( $post_id, '_imwb_videopress_post_video_clicks', $clicks, true );

   $ctr = ($clicks / $imp)*100;

   if ( !update_post_meta( $post_id, '_imwb_videopress_post_video_ctr', $ctr ) )
      add_post_meta( $post_id, '_imwb_videopress_post_video_ctr', $ctr, true );

   $aResponse['ctr'] = $ctr;

   echo json_encode($aResponse);
   die();
}

/**
 * Loads the front end scripts that runs the lead capture process
 * @return void
 */
function imwb_videopress_load_lc_script() {

   if(is_admin()) return;

   // Which ads are available to show
   $lcAvail = Array();

   if(imwb_videopress_get_option('leadcapturearoption') != 'N' && (!isset($_COOKIE['imwb_videopress_E_show']) || $_COOKIE['imwb_videopress_E_show'] != 'N'))
      $lcAvail['E'] = imwb_videopress_get_option('leadcapturearoption');

   if(imwb_videopress_get_option('leadcapturefburl') != '' && (!isset($_COOKIE['imwb_videopress_F_show']) || $_COOKIE['imwb_videopress_F_show'] != 'N'))
      $lcAvail['F'] = imwb_videopress_get_option('leadcapturefburl');

   if(imwb_videopress_get_option('leadcapturepinbd') != '' && (!isset($_COOKIE['imwb_videopress_P_show']) || $_COOKIE['imwb_videopress_P_show'] != 'N'))
      $lcAvail['P'] = imwb_videopress_get_option('leadcapturepinbd');

   if(imwb_videopress_get_option('leadcapturetumblr') != '' && (!isset($_COOKIE['imwb_videopress_T_show']) || $_COOKIE['imwb_videopress_T_show'] != 'N'))
      $lcAvail['T'] = imwb_videopress_get_option('leadcapturetumblr');

   if(!count($lcAvail)) {
       imwb_videopress_update_option('lastlcused','');
       return;
   }

   $lastUsed = imwb_videopress_get_option('lastlcused');

   // Remove the last type shown, if there are more to be used first
   if($lastUsed != '' && count($lcAvail)>1)
      unset($lcAvail[$lastUsed]);

   if(!count($lcAvail)) {
      imwb_videopress_update_option('lastlcused','');
      return;
   }

   list($k) = array_keys($lcAvail);
   $lcToShow  = array($k=>$lcAvail[$k]);

   $lcType = key($lcToShow);

   imwb_videopress_update_option('lastlcused',$lcType);
?>
	<script type="text/javascript">
      jQuery(document).ready(function($) {

      if(imwb_vpressCookie('imwb_videopress_<?php echo $lcType;?>_show') == 'N')
         return;

        var imwb_tpressLeadCapture = simpleModalLeadCapture(imwb_close_lightbox,'<?php echo $lcType;?>' );
<?php if(imwb_videopress_get_option('leadcaptureshow') == 'P'){ ?>
        var showTimer;
        showTimer = setTimeout(imwb_show_lightbox, <?php echo imwb_videopress_get_option("leadcaptureshowdelay")*1000;?>);
<?php } else { ?>
      var prevMouseY = 0;
      $(document).on("mouseleave mouseenter", $.proxy(function(e) {this.prevMouseY = 0}, this));
      $(document).mousemove($.proxy(function(e) {
         var mouseY = e.clientY;
         var deltaX = 0;
         if(this.prevMouseY == 0) this.prevMouseY = mouseY;
         if (this.prevMouseY != 0) {
            deltaX = this.prevMouseY - mouseY;
            this.prevMouseY = mouseY;
         }
         if(mouseY <= 10 && deltaX > 0) {
            imwb_show_lightbox();
         }
      }, this));

<?php } ?>
        function imwb_show_lightbox() {
// Activate the lightbox, depends on ad type
           if(imwb_vpressCookie('imwb_videopress_<?php echo $lcType;?>_show') == 'N')
              return;
           imwb_tpressLeadCapture.activate();
        }

// When close need to call this to set the cookie
        function imwb_close_lightbox() {
             imwb_vpressCookie('imwb_videopress_<?php echo $lcType;?>_show', 'N', <?php echo ((imwb_videopress_get_option("leadcapturecloseddays")== 0 ? 3650 :imwb_videopress_get_option("leadcapturecloseddays"))  *24);?>,'<?php echo COOKIEPATH;?>');
        }

      });

	</script>
<?php
}

/**
 * Alters the main home page meta query to first get posts that match the meta query, then
 * all other posts after that. If meta_key in use
 */
function imwb_videopress_meta_sql($clauses)
{
    global $wp_query;

    if( $wp_query->is_main_query()) {

    // check for order by custom_order
       if (($wp_query->get('meta_key') == '_imwb_videopress_post_video_views' || $wp_query->get('meta_key') == '_imwb_videopress_post_video_rating' || $wp_query->get('meta_key') == '_imwb_videopress_post_video_ctr') && $wp_query->get('orderby') == 'meta_value_num')
       {
           // change the inner join to a left outer join,
           // and change the where so it is applied to the join, not the results of the query
           $clauses['join'] = str_replace('INNER JOIN', 'LEFT OUTER JOIN', $clauses['join']).$clauses['where'];
           $clauses['where'] = '';
       }

       return $clauses;
    }
}

/**
 * Alters the rotator meta query to first get posts that match the meta query, then all other posts after that
 */
function imwb_videopress_rotator_meta_sql($clauses)
{
     // change the inner join to a left outer join,
     // and change the where so it is applied to the join, not the results of the query
     $clauses['join'] = str_replace('INNER JOIN', 'LEFT OUTER JOIN', $clauses['join']).$clauses['where'];
     $clauses['where'] = '';

     return $clauses;
}

/*
* RSS Feed functions
*
*/
add_action('rss2_ns', 'imwb_videopress_yahoo_media_tag');
add_action('rss_item', 'imwb_videopress_feed_item');
add_action('rss2_item', 'imwb_videopress_feed_item');
add_filter('the_excerpt_rss', 'imwb_videopress_feed_content');
add_filter('the_content_feed', 'imwb_videopress_feed_content');

function imwb_videopress_yahoo_media_tag() {
	echo 'xmlns:media="http://search.yahoo.com/mrss/"';
}

function imwb_videopress_feed_item($content) {
   global $post;

	$image_url = imwb_videopress_post_thumbnail_img_src ($post->ID);

	if (!empty($image_url)) {
		echo '<enclosure url="' . $image_url . '" type="image/jpg" />';
	echo '<media:content url="'.$image_url.'" width="200" height="140" medium="image" type="'.image_type_to_mime_type($type).'" />';
	}
}

function imwb_videopress_feed_content($content) {
   global $post;

   $image_src = imwb_videopress_post_thumbnail_img_src ( $post->ID);

   if(empty($image_src))
    return $content;

   $img = sprintf('<img src="%s" width="200px" height="140px" style="float:left; margin-right: 10px;">', $image_src);
   $content = '' . $img . '' . $content;

   return $content;
}
?>
