jQuery(document).ready(function($) {

   var totWizardSteps = parseInt($('input[name="totalwizzardsteps"]').val());
   var lastWizardStep = parseInt($('input[name="wizzardstep"]').val());

   if(lastWizardStep < totWizardSteps) {

      $('iframe').hide();

      if(lastWizardStep === 0 ) $('#wizzard-prev').attr('disabled', true);

      $( 'form' ).towizzard({
         'events': {
            next: function(nextStep) {
               $('input[name="wizzardstep"]').val(nextStep);
               if(nextStep == totWizardSteps)
                  $('#wizzard-next').attr('disabled', true);
               $('#wizzard-prev:disabled').attr('disabled', false);
            },
            previous: function(nextStep) {
               $('input[name="wizzardstep"]').val(nextStep);
               if(nextStep === 0)
                  $('#wizzard-prev').attr('disabled', true);
               $('#wizzard-next:disabled').attr('disabled', false);
            },
            reset: function(nextStep) {
               $('input[name="wizzardstep"]').val(0);
            }
         },
         'startStep': lastWizardStep
      });
   }

   $('#wizzard-next').on('click',function() {
      $('form').towizzard('next');
   });

   $('#wizzard-prev').on('click', function() {
      $('form').towizzard('previous');
   });

   $('.inputToggle').ifselshowthis();

   $( '.non-wizzard .wizzard-step-bar' ).on('click', function( e ) {
      e.preventDefault(); // Keep this AFTER the key filter above
      wizzardStepSwitch( $( this ) );
   });

   function wizzardStepSwitch ( el ) {
       var section = el.next( 'table.wizzard-step, table.non-wizzard-step' ),
           curOpen = $('.non-wizzard').find('table.wizzard-step, table.non-wizzard-step').filter( '.open' );

       if ( section.hasClass( 'open' ) ) {
          section.toggleClass( 'open' ).slideUp('fast');
       } else {
          if(curOpen.length > 0)
             curOpen.removeClass( 'open' ).slideUp('fast', function() {section.toggleClass( 'open' ).slideDown('fast'); } );
          else
             section.toggleClass( 'open' ).slideDown('fast');
       }
   }

   $('.wizzard-watch-vid >a').VideoPopup();

   $('.color-input').each(function(i, e) {
      var $e = $(e);
      $e.css('backgroundColor', $e.val());
      $e.keyup(function() {
         var _hex = $(this).val(), hex = _hex;
         if ( hex.charAt(0) != '#' )
            hex = '#' + hex;
         hex = hex.replace(/[^#a-fA-F0-9]+/, '');
         if ( hex != _hex )
            $(this).val(hex);
         if ( hex.length == 4 || hex.length == 7 )
            $(this).css('background-color', hex );
         else
            $(this).css('background-color', '');
      });
   });

   // Color Picker
   $('.pickcolor').on('click', function(e) {
       colorPicker = jQuery(this).next('div');
       input = jQuery(this).prev('input');
       $(colorPicker).farbtastic(input);
       colorPicker.show();
       e.preventDefault();
       $(document).mousedown( function() {
           $(colorPicker).hide();
       });
   });

   $('input[name="imwb_videopress_theme_options[postcontent]"]').change(function(){
      if($(this).val() == 'C')
         $('input[name="imwb_videopress_theme_options[postchars]"]').attr('readonly', false);
      else
          $('input[name="imwb_videopress_theme_options[postchars]"]').attr('readonly', true);
   });

   $('select[name="imwb_videopress_theme_options[pagemenutype]"]').change(function(){
      if($(this).val() == '1') {
         $('.pgmenutype_std').hide();
         $('.pgmenutype_custom').show();
      } else {
         $('.pgmenutype_std').show();
         $('.pgmenutype_custom').hide();
      }
   });

   $('select[name="imwb_videopress_theme_options[commenttype]"]').change(function(){
      if($(this).val() == '0') {
         $('.comment-type-wp').show();
         $('.comment-type-fb').hide();
      }
      else if($(this).val() == '1') {
         $('.comment-type-wp').hide();
         $('.comment-type-fb').show();
      }
      else if($(this).val() == '2') {
         $('.comment-type-wp').show();
         $('.comment-type-fb').show();
      }
      else {
         $('.comment-type-wp').hide();
         $('.comment-type-fb').hide();
      }
   });

   $('input[name="imwb_videopress_theme_options[leadcapturearoption]"]').change(function(){
      var val = $(this).val();
      if(val == 'A') {
         $('.aweber-field').show();
         $('.getresponse-field').hide();
         $('.arformoth-field').hide();
         $('.arform-field').hide();
         $('.arformurl-field').hide();
         $('.ar-field').show();
      }
      else if(val == 'G') {
         $('.aweber-field').hide();
         $('.getresponse-field').show();
         $('.arformoth-field').hide();
         $('.arform-field').hide();
         $('.arformurl-field').hide();
         $('.ar-field').show();
      }
      else if(val == 'N') {
         $('.ar-field').hide();
         $('.aweber-field').hide();
         $('.getresponse-field').hide();
         $('.arformoth-field').hide();
         $('.arform-field').hide();
         $('.arformurl-field').hide();
      }
      else if(val == 'I') {
         $('.aweber-field').hide();
         $('.getresponse-field').hide();
         $('.arformoth-field').hide();
         $('.arform-field').show();
         $('.arformurl-field').hide();
         $('.ar-field').show();
      }
      else if(val == 'M') {
         $('.aweber-field').hide();
         $('.getresponse-field').hide();
         $('.arformoth-field').hide();
         $('.arform-field').show();
         $('.arformurl-field').show();
         $('.ar-field').show();
      }
      else if(val == 'O') {
         $('.aweber-field').hide();
         $('.getresponse-field').hide();
         $('.arformurl-field').hide();
         $('.arform-field').show();
         $('.arformoth-field').show();
         $('.ar-field').show();
      }

   });

   $('#aweber-deauth').on('click', function() {
      if(confirm('Are you sure you wish to remove the connection to AWeber')) {
      $('input[name="aweber-auth"]').val('deauth');
         $('input[type="submit"]').click();
      }
   });

	$('#imwb_videopressClearCookie').on('click', function() {

      var data = {
          action :'imwb_videopress_clear_lc_cookie',
          nonce : IMWB_VIDEOPRESS_Ajax.nonce
      };

      $.post(IMWB_VIDEOPRESS_Ajax.ajaxurl+'?r='+(Math.random()*445), data);

      return false;
	});

});

function imwb_ms_unselectAll(selObj)
{
   for (i = 0; i < selObj.options.length; i ++)
   {
      selObj.options[i].selected = false;
   }
}
