;(function( $, window, document, undefined )
{
	$.fn.doubleTapToGo = function( params )
	{
		if( !( 'ontouchstart' in window ) &&
			!navigator.msMaxTouchPoints &&
			!navigator.userAgent.toLowerCase().match( /windows phone os 7/i ) ) return false;

		this.each( function()
		{
			var curItem = false;

			$( this ).on( 'click', function( e )
			{
				var item = $( this );
				if( item[ 0 ] != curItem[ 0 ] )
				{
					e.preventDefault();
					curItem = item;
				}
			});

			$( document ).on( 'click touchstart MSPointerDown', function( e )
			{
				var resetItem = true,
               parents = $( e.target ).parents();

				for( var i = 0; i < parents.length; i++ )
					if( parents[ i ] == curItem[ 0 ] )
						resetItem = false;

				if( resetItem )
					curItem = false;
			});
		});
		return this;
	};

	$.fn.scrollToTop = function()
	{
      if ($(window).scrollTop() != '0') {
         $(this).fadeIn('slow');
      }
      var scrollDiv = $(this);
      $(window).scroll(function() {
         if ($(window).scrollTop() == '0') {
            $(scrollDiv).fadeOut('slow');
         }
         else {
            $(scrollDiv).fadeIn('slow');
        }
      });
      $(this).on('click', function() {
        $('html, body').animate({ scrollTop: 0 }, 'slow');
      });
   };
})( jQuery, window, document );

/**
 * @preserve JSizes - JQuery plugin v0.33
 *
 * Licensed under the revised BSD License.
 * Copyright 2008-2010 Bram Stein
 * All rights reserved.
 */
/*global jQuery*/
(function ($) {
        'use strict';
        var num = function (value) {
                        return parseInt(value, 10) || 0;
                };
        var Point = function(x, y) {
             return {
                 'x': x,
                 'y': y,
                 'left': x,
                 'top': y
             };
         };

        /**
         * Sets or gets the values for min-width, min-height, max-width
         * and max-height.
         */
        $.each(['min', 'max'], function (i, name) {
                $.fn[name + 'Size'] = function (value) {
                        var width, height;
                        if (value) {
                                if (value.width !== undefined) {
                                        this.css(name + '-width', value.width);
                                }
                                if (value.height !== undefined) {
                                        this.css(name + '-height', value.height);
                                }
                        } else {
                                width = this.css(name + '-width');
                                height = this.css(name + '-height');
                                // Apparently:
                                //  * Opera returns -1px instead of none
                                //  * IE6 returns undefined instead of none
                                return {'width': (name === 'max' && (width === undefined || width === 'none' || num(width) === -1) && Number.MAX_VALUE) || num(width),
                                                'height': (name === 'max' && (height === undefined || height === 'none' || num(height) === -1) && Number.MAX_VALUE) || num(height)};
                        }
                        return this;
                };
        });

        /**
         * Returns whether or not an element is visible.
         */
        $.fn.isVisible = function () {
                return this.is(':visible');
        };

        /**
         * Sets or gets the values for border, margin and padding.
         */
        $.each(['border', 'margin', 'padding'], function (i, name) {
                $.fn[name] = function (value) {
                        if (value) {
                                if (value.top !== undefined) {
                                        this.css(name + '-top' + (name === 'border' ? '-width' : ''), value.top);
                                }
                                if (value.bottom !== undefined) {
                                        this.css(name + '-bottom' + (name === 'border' ? '-width' : ''), value.bottom);
                                }
                                if (value.left !== undefined) {
                                        this.css(name + '-left' + (name === 'border' ? '-width' : ''), value.left);
                                }
                                if (value.right !== undefined) {
                                        this.css(name + '-right' + (name === 'border' ? '-width' : ''), value.right);
                                }
                        } else {
                                return {top: num(this.css(name + '-top' + (name === 'border' ? '-width' : ''))),
                                                bottom: num(this.css(name + '-bottom' + (name === 'border' ? '-width' : ''))),
                                                left: num(this.css(name + '-left' + (name === 'border' ? '-width' : ''))),
                                                right: num(this.css(name + '-right' + (name === 'border' ? '-width' : '')))};
                        }
                        return this;
                };
        });

      /// Returns the "fixed" position of the element; i.e., the position relative to the browser window.
      $.fn.fixedPosition = function () {
          var offset = this.offset();
          var $doc = $(document);
          var bodyOffset = $(document.body).outerOffset();
          return new Point(offset.left - $doc.scrollLeft() + bodyOffset.left, offset.top - $doc.scrollTop() + bodyOffset.top);
      };

      /// Returns an element's offset relative to its outer size; i.e., the sum of its left and top margin, padding, and border.
      $.fn.outerOffset = function () {
          var margin = this.margin();
          var padding = this.padding();
          var border = this.border();
          return new Point(
              margin.left + padding.left + border.left,
              margin.top + padding.top + border.top
          );
      };


}(jQuery));

(function($,sr){

  // debouncing function from John Hann
  // http://unscriptable.com/index.php/2009/03/20/debouncing-javascript-methods/
  var debounce = function (func, threshold, execAsap) {
      var timeout;

      return function debounced () {
          var obj = this, args = arguments;
          function delayed () {
              if (!execAsap)
                  func.apply(obj, args);
              timeout = null;
          }

          if (timeout)
              clearTimeout(timeout);
          else if (execAsap)
              func.apply(obj, args);

          timeout = setTimeout(delayed, threshold || 100);
      };
  };
  // smartresize
  jQuery.fn[sr] = function(fn){  return fn ? this.on('resize', debounce(fn)) : this.trigger(sr); };

})(jQuery,'smartresize');

;(function( $, window, document, undefined )
{

   SimpleModalLeadCapture = function(closeCallback, lcType) {
      if(closeCallback !== undefined)
         this.closeCallback = closeCallback;
      this.lcType = lcType;
      this.form = undefined;
      this.error = [];
      $('#smcf-leadcapture a.smcf-close').on('click', $.proxy(this.close, this));
   };

   SimpleModalLeadCapture.prototype = {

      activate: function() {

         if(this.lcType == 'E') {
            this.login = $('#leadcaptureform');
            this.form = '#leadcaptureform';
            if (!$('#smcf-container').length) {
               $('#smcf-leadcapture').modal({overlayId: 'smcf-overlay',
                                             containerId: 'smcf-container',
                                             opacity:85,
                                             onShow: $.proxy(this.showForm, this),
                                             position: ['15%', null],
                                             zIndex:10000
               });
            }
            else {
               this.showForm();
            }
         }
         else if(this.lcType == 'P' || this.lcType == 'T' || this.lcType == 'F') {
            if (!$('#smcf-container').length) {
               $('#smcf-leadcapture').modal({overlayId: 'smcf-overlay',
                                             containerId: 'smcf-container',
                                             opacity:85,
                                             onShow: $.proxy(this.show, this),
                                             position: ['15%', null],
                                             zIndex:10000
                });
            }
            else {
               this.showForm();
            }
         }
      },
      show: function (obj) {
         this.dialog = obj || this.dialog;
         this.dialog.container.css({height:'auto'});
      },
      showForm: function (obj) {
         this.dialog = obj || this.dialog;
         var form = $(this.form),
         fields = $('.smcf-leadcapture-fields', form[0]),
         activity = $('.smcf-activity', form[0]);
         // update and focus dialog
         this.dialog.container.css({height:'auto'});
         // remove any existing errors or messages
         this.clear(this.dialog.container[0]);

         form.unbind('submit.simplemodal').on('submit.simplemodal', $.proxy(function (e) {
            e.preventDefault();
            // remove any existing errors or messages
            this.clear(this.dialog.container[0]);
            if (this.isValid(form)) {
               fields.hide(); activity.show();
               $.ajax({url: form[0].action,
                     data: form.serialize(),
                     type: 'POST',
                     cache: false,
                     context: this,
                     success: function (resp) {
                      this.close();
                     },
                     error: function (xhr) {
                      $('input:last', form[0]).before(
                         $(document.createElement('div')).html('<strong>ERROR</strong>: ' + xhr.statusText).attr('id', 'login_error'));
                      activity.hide(); fields.show();
                     }
               });
            }
            else {
               this.showFormError(form, this.error);
            }
         }, this));
      },

      close: function (obj) {
         if (this.closeCallback && typeof(this.closeCallback) === 'function') {
            this.closeCallback.call(this);
         }
          $.modal.close();
      },

      /* utility functions */
      clear: function (context) {
         $('#login_error, .message', context).remove();
      },

      isValid: function (form) {
         var email = $('.user_email', form[0]),
         firstname = $('.firstname', form[0]),
         fields = $(':text', form[0]),
         valid = true;
         this.error = [];
         if (firstname.length && !$.trim(firstname.val())) {
            this.error.push('empty_firstname');
            valid = false;
         }
         else if (email.length && !$.trim(email.val())) {
            this.error.push('empty_email');
            valid = false;
         }
         var empty_count = 0;
         fields.each(function () {
            if (!$.trim(this.value)) {
               empty_count++;
            }
         });
         if (fields.length > 1 && empty_count === fields.length) {
          this.error = ['empty_all'];
          valid = false;
         }
         return valid;
      },

      showFormError: function (form, keys) {
         keys = $.map(keys, function (key) {
            return SimpleModalLeadCaptureL10n[key] ? SimpleModalLeadCaptureL10n[key] : key;
         });

         $('input:last', form[0]).before($('<div id="login_error"></div>').html(keys.join('<br>')));
      }
   };

   simpleModalLeadCapture = function(closeCallback, lcType){
      return new SimpleModalLeadCapture(closeCallback, lcType);
   };

})( jQuery, window, document );

var imwb_vpressCookie = function(name, value, expireHours, path) {
   var t;
   // name and at least value given, set cookie...
   if (arguments.length > 1 ) {

      if (expireHours === null || expireHours === undefined) {
          expireHours = 7;
      }

      if (typeof expireHours === 'number') {
          t = new Date();
          t.setTime(t.getTime()+(expireHours*60*60*1000));
      }

      value = String(value);

      document.cookie = name+'='+value+'; expires='+t.toUTCString()+'; path='+path+';';

      return;
   }

   // name only, get cookie...
   var pairs = document.cookie.split('; ');
   for (var i = 0, pair; pair = pairs[i] && pairs[i].split('='); i++) {
      if (pair[0] === name) return pair[1] || '';
   }


   return null;
};

jQuery(document).ready(function($) {

   $('#videos_wrapper').masonry({itemSelector: '.video',stamp: '.stamp', gutter: 8, columnWidth: parseInt(IMWB_VIDEOPRESS.masnoryCW)});
   $('#carousel').contentcarousel();

   $('#share-button').on('click', function() {
      if($(this).hasClass('active')) {
         $('#share-button').removeClass('active');
         $('#social_actions').slideUp('fast');
      }
      else {
         $(this).addClass('active');
         $('#social_actions').slideDown('slow');
      }

   });

   $('#social_actions div.close').on('click', function() {
      $('#share-button').removeClass('active');
      $('#social_actions').slideUp('fast');
   });

   $('#navigation li:has(ul)' ).doubleTapToGo();
   $('button.categories').on('click', function(event) {
      var that=$(this);
      var cm = $('div.categories');
      if(that.hasClass('active')) {
         cm.addClass('hidden');
         that.removeClass('active');
      }
      else {
//         var o=that.fixedPosition();
         var o=that.position();
         var mt = that.height()+o.top;
         that.addClass('active');
         cm.css('left', o.left).css('top', mt).removeClass('hidden');
      }

      event.stopPropagation();
   });
   $('div.categories.dropdown').on('click', function(event){
      event.stopPropagation();
   });
});

function imwb_videopress_window_open(href, url, text) {
   href = href.replace(/{URL}/g, encodeURIComponent(url));
   if(text !== undefined)
      href = href.replace(/{TEXT}/g, encodeURIComponent(text));
   window.open(href, 'popUp', 'width=620,height=440');
}
