<?php
add_action( 'admin_init', 'imwb_videopress_theme_options_init' );
add_action( 'admin_menu', 'imwb_videopress_theme_options_add_page' );

require_once ( get_template_directory() . '/getresponse-api/jsonRPCClient.php' );
require_once ( get_template_directory() . '/aweber_api/aweber_api.php');
require_once ( get_template_directory() . '/HtmlFormParser.php');

/**
 * Init plugin options to white list our options
 */
function imwb_videopress_theme_options_init(){
	wp_register_style( 'imwb_videopress-theme-options-stylesheet', get_template_directory_uri().'/admin_options_page.css' );
	wp_register_script( 'imwb_videopress-theme-options-script', get_template_directory_uri().'/scripts/admin_options'.MIN_MODE.'.js' );
	wp_register_script( 'imwb_videopress-theme-options-wizzard-script', get_template_directory_uri().'/scripts/jquery.wizzard'.MIN_MODE.'.js' );
	wp_register_script( 'imwb_videopress-theme-options-ifselshowthis-script', get_template_directory_uri().'/scripts/jquery.ifselshowthis'.MIN_MODE.'.js' );
	wp_register_script( 'imwb_videopress-theme-options-videopopup-script', get_template_directory_uri().'/scripts/jquery.videopopup.min.js' );
}

/**
 * Load up the menu page
 */
function imwb_videopress_theme_options_add_page() {

	$page = add_theme_page( __( 'Theme Options', 'imwb_videopress' ), __( 'Theme Options', 'imwb_videopress' ), 'edit_theme_options', 'imwb_videopress_theme_options', 'imwb_videopress_theme_options_do_page' );

	/* Using registered $page handle to hook stylesheet loading */
   add_action( 'admin_print_styles-' . $page, 'imwb_videopress_admin_styles' );
   add_action( 'admin_print_scripts-' . $page, 'imwb_videopress_admin_scripts' );
  	add_action( 'load-' . $page, 'imwb_videopress_theme_options_take_action');

}

function imwb_videopress_admin_styles() {
   wp_enqueue_style( 'farbtastic' );
   wp_enqueue_style('imwb_videopress-theme-options-stylesheet');
   wp_enqueue_style('jquery-style', '//code.jquery.com/ui/1.10.3/themes/redmond/jquery-ui.css');
   wp_deregister_style( 'wp-jquery-ui-dialog' );
}

function imwb_videopress_admin_scripts() {
   wp_enqueue_script('jquery-ui-core');
   wp_enqueue_script('jquery-ui-dialog');
   wp_enqueue_script( 'farbtastic' );
   wp_enqueue_script('imwb_videopress-theme-options-script');
   wp_enqueue_script('imwb_videopress-theme-options-wizzard-script');
   wp_enqueue_script('imwb_videopress-theme-options-ifselshowthis-script');
   wp_enqueue_script('imwb_videopress-theme-options-videopopup-script');
   wp_localize_script('imwb_videopress-theme-options-script', 'IMWB_VIDEOPRESS_Ajax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ), 'nonce' => wp_create_nonce( 'imwb_videopress_clear_cookie_nonce' )) );

}

/**
 * Returns the default options for Twenty Eleven.
 *
 */
function imwb_videopress_get_default_theme_options() {
	$default_theme_options = array(
     	'wizzardstep' => '0',
  		'lastlcused' => '',
   	'siteheader' => 'T',
	   'faviconurl' => '',
	   'videothumbnw' => 'N',
	   'headerbgcol' => '#FFFFFF',
	   'hidepagemenu' => 'N',
	   'pagemenutype' => '0',
	   'pagemenubgcol' => '#FFFFFF',
  	   'pagemenutxtcol' => '#000000',
	   'homepagemenu' => 'N',
	   'homepagemenutxt' => 'Home',
	   'excludepages' => '',
	   'hidecatmenu' => 'N',
	   'ravcatmenu' => 'N',
	   'ravcatmenutxt' => 'Recently Added',
	   'ravcatmenutitle' => 'Recently Added Videos',
	   'mvvcatmenu' => 'N',
	   'mvvcatmenutxt' => 'Most Viewed',
	   'mvvcatmenutitle' => 'Most Viewed Videos',
	   'trvcatmenu' => 'N',
	   'trvcatmenutxt' => 'Top Rated',
      'trvcatmenutitle' => 'Top Rated Videos',
  	   'tdvcatmenu' => 'N',
      'tdvcatmenutxt' => 'Trending',
      'tdvcatmenutitle' => 'Trending Videos',
	   'othercatmenu' => 'N',
	   'catmenutxtcol' => '#FFFFFF',
  	   'catmenuseltxtcol' => '#000000',
 	   'catmenubgcol' => '#4350D6',
	   'excludecats' => '',
	   'showrotatorhp' => 'Y',
	   'showrotatorap' => 'Y',
	   'showrotatorsp' => 'Y',
	   'showrotatorpg' => 'Y',
	   'fpbgimage' => '1',
	   'fpbannerbgimg' => '',
      'fplistorder' => '0',
      'postsperrotator' => '10',
      'fpexcludecats' => '',
      'fptitlecol' => '#1b7fcc',
      'fptitlehvrcol' => '#9C9C9C',
      'fpbannerbgcol' => '#abbfda',
      'fpcaptionbgcol' => '#f1d809',
	   'fpbackground' => 'C',
	   'hidesearch' => 'N',
 	   'searchtext' => 'Search this site...',
  	   'hidefooter' => 'N',
	   'listorder' => '0',
		'homesidebar' => '2',
		'homesidebarbgcol' => '#F9F9F9',
		'homesidebarbdrcol' => '#C6C6C6',
		'widgettitlebgcol' => '#6acbfe',
		'widgettitletxtcol' => '#040404',
   	'sidebartextcol' => '#333333',
		'posttitlecol' => '#000000',
		'posttitlehvrcol' => '#9C9C9C',
		'postdesccol' => '#7c7b7a',
		'postcontentbgcol' => '#FFFFFF',
 	   'postcontentbdrcol' => '#CCCACA',
		'showtitle' => '1',
		'postcontent' => 'C',
		'postchars' => '35',
   	'postmoretext' => '[More]',
		'commenttype' => '0',
   	'fbappid' => '',
   	'hideptcommenttime' => 'N',
		'commentstats' => '1',
		'viewstats' => '1',
		'viewrating' => '1',
    	'ptbgcol' => '#ffffff',
		'ptcontentbdrcol' => '#CCCACA',
		'hidepttitle' => 'N',
		'hideptdetails' => 'N',
		'hideptviewstats' => 'N',
		'hideptsocialbtns' => 'N',
		'shareoptions' => 'F,T,P,L,G,B,R',
		'hideptrating' => 'N',
		'hidepttagstats' => 'N',
		'hideptcatstats' => 'N',
		'hideptrelated' => 'N',
		'pagesidebar' => '0',
		'postsidebar' => '2',
		'hidepgtitle' => 'N',
		'hidepgdetails' => 'N',
		'hidepgcomments' => 'N',
      'sneakylikebtn' => '1',
		'footerbgcol' => '#FAF7F7',
   	'footerbdrcol' => '#dddddd',
   	'autoplay' => '1',
   	'autogenthumbs' => '1',
   	'storethumbs' => '0',
   	'ytmodestbrand' => '0',
   	'genschemaorg' => '1',
   	'leadcapturearoption' => 'N',
   	'leadcaptureardesc' => 'Do you like our videos? Want to see more?  Fill in your details below to join our newsletter & receive updates about new videos',
   	'aweber_auth_code' => '',
   	'aweber_consumer_key' => '',
   	'aweber_consumer_secret' => '',
   	'aweber_access_key' => '',
   	'aweber_access_secret' => '',
   	'aweber_list' => '',
   	'getresponse_api_key' => '',
   	'getresponse_campaign' => '',
   	'ar_formurl' => '',
   	'ar_form' => '',
   	'ar_formfldemail' => '',
   	'ar_formfldname' => '',
   	'leadcapturefburl' => '',
   	'leadcapturepinbd' => '',
   	'leadcapturetumblr' => '',
   	'leadcaptureshow' => 'L',
   	'leadcaptureshowdelay' => '3',
   	'leadcapturecloseddays' => '7',
   	'headerscripts' => '',
   	'homepagescripts' => ''
	);

	return $default_theme_options;
}

$sidebar_options = array(
	'0' => array('label' => __('Off', 'imwb_videopress')),
	'1' => array('label' => __('Left', 'imwb_videopress')),
	'2' => array('label' => __('Right', 'imwb_videopress'))
);

$yesno_options = array(
	'1' => array('label' => __('Yes', 'imwb_videopress')),
	'0' => array('label' => __('No', 'imwb_videopress'))
);

$listorder_options = array(
	'0' => array('label' => __('Newest', 'imwb_videopress')),
	'1' => array('label' => __('Top Rated', 'imwb_videopress')),
	'2' => array('label' => __('Most Viewed', 'imwb_videopress')),
   '3' => array('label' => __('Trending', 'imwb_videopress'))
);

$pagemenu_options = array(
	'0' => array('label' => __('Page Menu', 'imwb_videopress')),
	'1' => array('label' => __('Custom Menu', 'imwb_videopress'))
);

$comments_options = array(
	'0' => array('label' => __('Wordpress Comments', 'imwb_videopress')),
	'1' => array('label' => __('Facebook Comments', 'imwb_videopress')),
   '2' => array('label' => __('Wordpress & Facebook Comments', 'imwb_videopress')),
   '3' => array('label' => __('None', 'imwb_videopress'))
);


// Function to get a list of the Blogs pages and return a <option> list of them
function cvp_get_blog_pages($parentId = 0, $selected=array(), $level = 0) {
   $retStr = '';

   if(!is_array($selected))
      $selected = array();

   $pages = get_pages('parent='.$parentId.'&child_of='.$parentId);
   if(count($pages) > 0){
      foreach($pages as $page){
        $sel = false;
        if(in_array($page->ID,$selected))
        		$sel = true;
        $retStr.= "<option value='" . $page->ID . "' ".(($sel)?' selected="selected"':'').'>'.str_repeat('  - ', $level).esc_html($page->post_title).'</option>'.cvp_get_blog_pages($page->ID, $selected, $level+1);
      }
   }

   return $retStr;
}

// Function to get a list of the Blogs Categories and return a <option> list of them
function cvp_get_blog_categories($parentId = 0, $selected=array(), $level = 0) {
   $retStr = '';

   if(!is_array($selected))
      $selected = array();

	$cats = get_categories('child_of='.$parentId.'&parent='.$parentId.'&hide_empty=0');
   if(count($cats) > 0){
      foreach($cats as $cat){
        $sel = false;
        if(in_array($cat->cat_ID,$selected))
        		$sel = true;
        $retStr.= "<option value='" . $cat->cat_ID . "' ".(($sel)?' selected="selected"':'').'>'.str_repeat('  - ', $level).esc_html($cat->cat_name).'</option>'.cvp_get_blog_categories($cat->cat_ID, $selected, $level+1);
      }
   }

   return $retStr;
}

/**
 * Create the options page
 */
function imwb_videopress_theme_options_do_page() {
   global $sidebar_options, $yesno_options, $listorder_options, $pagemenu_options, $comments_options;

   if (imwb_videopress_get_option('wizzardstep') < IMWB_VIDEOPRESS_WIZZARD_STEPS) {
      $pageTitle = __( 'Covert VideoPress Theme Wizard', 'imwb_videopress' );
      $wizzardMode = true;
   }
   else {
      $pageTitle =  __( 'Covert VideoPress Theme Options', 'imwb_videopress' );
      $wizzardMode = false;
   }
?>

	<div class="wrap">
	<div id="imwb_plugin_header">
	<a href="https://imwealthbuilders.com" target="_blank"><img src="<?php echo get_template_directory_uri(). '/images/imwblogo.png';?>"></a>
	<span id="imwb_plugin_header_link"><a href="https://imwealthbuilders.com/newplugins" target="_blank">Click Here To See Our Latest WP Plugins</a></span>
   <h2><?php echo $pageTitle;?></h2>
	<div style="clear: both"></div>
	</div>
   <?php if(isset($_REQUEST['page']) && $_REQUEST['page'] == 'imwb_videopress_theme_options' && isset($_REQUEST['action']) && $_REQUEST['action'] == 'update') : ?>
      <div class="imwb_cabar_active_panel"><p><strong><?php _e( 'Options saved', 'imwb_videopress' ); ?></strong></p></div>
   <?php endif; ?>
	<div id="imwb_plugin_options_editor">

		<?php echo "<h2>" . __( 'Theme Options', 'imwb_videopress' ) . '</h2>'; ?>

		<form class="non-wizzard" method="post" action="" enctype="multipart/form-data">
			<?php settings_fields( 'imwb_videopress_options' ); ?>
         <input type="hidden" name="aweber-auth" value="">
         <input type="hidden" name="wizzardstep" value="<?php esc_attr_e(imwb_videopress_get_option('wizzardstep')); ?>">
         <input type="hidden" name="totalwizzardsteps" value="<?php echo IMWB_VIDEOPRESS_WIZZARD_STEPS; ?>">

   		<div class="wizzard-step-bar" data-rel-step="1"><?php _e( '1. Header & Footer Configuration', 'imwb_videopress' ); ?></div>
   		<table id="step1" class="widefat wizzard-step">
   		  <tbody>
   		  <tr class="desc">
   		   <td colspan="2"><div class="wizzard-step-stage"></div><div class="desc"><?php _e( 'Here you select if you want to show a text title or image in your blogs header.<br><br>Then you will need to either enter your blogs title or upload a logo image with a maxium width of 400 pixels and a maximum height of 50 pixels. This will be displayed at the top of all your blog pages, before the content. Here you also configure how you want the menus, search field, footer and social buttons to appear', 'imwb_videopress' ); if($wizzardMode) _e( '<br><br>Click the "Next" button to proceed to the next step.', 'imwb_videopress' );?><div class="wizzard-watch-vid"><a href="<?php echo is_ssl() ? 'https' : 'http';?>://youtube.com/embed/50__LPvPoHE" title="<?php _e( 'Click To Watch A Tutorial Video', 'imwb_videopress' ); ?>"><img src='<?php echo get_template_directory_uri();?>/images/wizard-watch-vid.png'></a></div></div></td>
   		  </tr>
 		     <tr>
		      <td colspan="2" class="label align-left"><?php _e( 'In the header section of your blog do you want to show a ', 'imwb_videopress' ); ?>
		        <input class="inputToggle" data-ifsel-show-this=".siteheader-val-t" type="radio" name="imwb_videopress_theme_options[siteheader]" value="T" <?php echo imwb_videopress_get_option('siteheader') == "T" ? "checked='Yes'" : "" ?> />
		     <?php _e( ' text title or ', 'imwb_videopress' ); ?>
		        <input class="inputToggle" data-ifsel-show-this=".siteheader-val-i" type="radio" name="imwb_videopress_theme_options[siteheader]" value="I" <?php echo imwb_videopress_get_option('siteheader') == "I" ? "checked='Yes'" : "" ?> />
		     <?php _e( ' image.', 'imwb_videopress' ); ?>
		       </td>
		      </tr>
		     </tbody>
   		  <tbody class="siteheader-val-t">
   		  <tr><td class="label"><?php _e( 'Header Background Color', 'imwb_videopress' ); ?></td>
   		  	 <td>
   		  	   <input class="color-input" type="text" name="imwb_videopress_theme_options[headerbgcol]" value="<?php echo esc_attr( imwb_videopress_get_option('headerbgcol') ); ?>"/>
   		  	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
   		  	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
   		  	</td>
   		  </tr>
   		  <tr valign="top"><td class="label"><?php _e( 'Title', 'imwb_videopress' ); ?></td>
   		   <td>
   		     <input class="regular-text" type="text" value="<?php form_option('blogname'); ?>" name="imwb_videopress_theme_options[blogname]">
   		   </td>
   		  </tr>
   		  <tr valign="top"><td class="label"><?php _e( 'Tagline', 'imwb_videopress' ); ?></td>
   		   <td>
   		     <input class="regular-text" type="text" value="<?php form_option('blogdescription'); ?>" name="imwb_videopress_theme_options[blogdescription]">
   		   </td>
   		  </tr>
   		  <tr valign="top"><td class="label"><?php _e( 'Text color', 'imwb_videopress' ); ?></td>
   		    <td>
   		      <input class="color-input" type="text" name="imwb_videopress_theme_options[headertextcol]" value="#<?php echo esc_attr( get_theme_mod('header_textcolor') ); ?>"/>
   		      <input type='button' class='pickcolor button-secondary' value='Select Color'>
   		      <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
   		   </td>
   		  </tr>
   		  </tbody>
   		  <tbody class="siteheader-val-i">
   		  <tr valign="top"><td class="label"><?php _e( 'Upload a header image', 'imwb_videopress' ); ?></td>
   		   <td>
   		   	<input type="file" name="header_img"  id="header_img" />
   		   </td>
   		  </tr>
   		</tbody>
   		<tbody>
   		 <tr><td  colspan="2" class="wide-label"><?php _e( 'Pages Menu', 'imwb_videopress' ); ?></td></tr>
   		 <tr><td class="label"><?php _e( 'Hide Menu', 'imwb_videopress' ); ?></td>
   			 <td><input id="imwb_videopress_theme_options[hidepagemenu]" type="checkbox" name="imwb_videopress_theme_options[hidepagemenu]" value="Y" <?php echo imwb_videopress_get_option('hidepagemenu') == "Y" ? "checked='Yes'" : "" ?> />

   			</td>
   		 </tr>
   		 <tr><td class="label"><?php _e( 'Standard Page Menu or Custom Menu', 'imwb_videopress' ); ?></td>
   			 <td>
   		    <select id="imwb_videopress_theme_options[pagemenutype]" class="regular-text" type="text" name="imwb_videopress_theme_options[pagemenutype]" >
   		    <?php
   		     foreach ($pagemenu_options as $key => $value) {
   		        $selected = (imwb_videopress_get_option('pagemenutype') == $key) ? " selected" : "";
   		        echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
   		     }
   		    ?>
   		    </select>
   			</td>
   		 </tr>
   		 <tr class="pgmenutype_custom" <?php echo imwb_videopress_get_option('pagemenutype') == '0' ? 'style="display: none;"' : ""; ?> ><td></td><td>Use the Appearance->Menus option to create/edit the custom menu</td></tr>
   		 <tr class="pgmenutype_std" <?php echo imwb_videopress_get_option('pagemenutype') == '1' ? 'style="display: none;"' : ""; ?>><td class="label"><?php _e( 'Home Menu Option', 'imwb_videopress' ); ?></td>
   			 <td>Menu Text <input type="text" name="imwb_videopress_theme_options[homepagemenutxt]" value="<?php echo esc_attr( imwb_videopress_get_option('homepagemenutxt') ); ?>" size="30"/> - Don't Show <input id="imwb_videopress_theme_options[homepagemenu]" type="checkbox" name="imwb_videopress_theme_options[homepagemenu]" value="Y" <?php echo imwb_videopress_get_option('homepagemenu') == "Y" ? "checked='Yes'" : "" ?> />

   			</td>
   		 </tr>
   		 <tr class="pgmenutype_std" <?php echo imwb_videopress_get_option('pagemenutype') == '1' ? 'style="display: none;"' : ""; ?>><td class="label top"><?php _e( 'Pages to Exclude', 'imwb_videopress' ); ?></td>
   		 	 <td><select size="7"  multiple="multiple"  style="width:340px; height:auto;" name="imwb_videopress_theme_options[excludepages][]" id="imwb_videopress_theme_options[excludepages]" >
   			<?php
   						$currentpages = explode(",", htmlspecialchars(imwb_videopress_get_option('excludepages')) );
   		          echo cvp_get_blog_pages(0, $currentpages);

   			?></select>   <br>
   			<a href="javascript:void(0)" onclick="imwb_ms_unselectAll(document.getElementById('imwb_videopress_theme_options[excludepages]'))"><?php _e('Unselect All','imwb_videopress'); ?></a>
   		 	 </td>
   		 </tr>
   		 <tr><td class="label"><?php _e( 'Text Color', 'imwb_videopress' ); ?></td>
   		 	 <td>
   		 	   <input class="color-input" type="text" name="imwb_videopress_theme_options[pagemenutxtcol]" value="<?php echo esc_attr( imwb_videopress_get_option('pagemenutxtcol') ); ?>"/>
   		 	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
   		 	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
   		 	</td>
   		 </tr>
   		 <tr><td class="label"><?php _e( 'Background Color', 'imwb_videopress' ); ?></td>
   		 	 <td>
   		 	   <input class="color-input" type="text" name="imwb_videopress_theme_options[pagemenubgcol]" value="<?php echo esc_attr( imwb_videopress_get_option('pagemenubgcol') ); ?>"/>
   		 	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
   		 	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
   		 	</td>
   		 </tr>
   		 <tr><td  colspan="2" class="wide-label"><?php _e( 'Category Menu', 'imwb_videopress' ); ?></td></tr>
   		 <tr><td class="label"><?php _e( 'Hide Menu', 'imwb_videopress' ); ?></td>
   			 <td><input id="imwb_videopress_theme_options[hidecatmenu]" type="checkbox" name="imwb_videopress_theme_options[hidecatmenu]" value="Y" <?php echo imwb_videopress_get_option('hidecatmenu') == "Y" ? "checked='Yes'" : "" ?> />

   			</td>
   		 </tr>
   		 <tr><td class="label"><?php _e( 'Text Color', 'imwb_videopress' ); ?></td>
   			 <td>
   			   <input class="color-input" type="text" name="imwb_videopress_theme_options[catmenutxtcol]" value="<?php echo esc_attr( imwb_videopress_get_option('catmenutxtcol') ); ?>"/>
   			   <input type='button' class='pickcolor button-secondary' value='Select Color'>
   			   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
   			</td>
   		 </tr>
   		 <tr><td class="label"><?php _e( 'Selected Menu Text Color', 'imwb_videopress' ); ?></td>
   			 <td>
   			   <input class="color-input" type="text" name="imwb_videopress_theme_options[catmenuseltxtcol]" value="<?php echo esc_attr( imwb_videopress_get_option('catmenuseltxtcol') ); ?>"/>
   			   <input type='button' class='pickcolor button-secondary' value='Select Color'>
   			   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
   			</td>
   		 </tr>
   		 <tr><td class="label"><?php _e( 'Background Color', 'imwb_videopress' ); ?></td>
   			 <td>
   			   <input class="color-input" type="text" name="imwb_videopress_theme_options[catmenubgcol]" value="<?php echo esc_attr( imwb_videopress_get_option('catmenubgcol') ); ?>"/>
   			   <input type='button' class='pickcolor button-secondary' value='Select Color'>
   			   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
   			</td>
   		 </tr>
   		 <tr><td class="label top"><?php _e( 'Recently Added Videos Menu', 'imwb_videopress' ); ?></td>
   			 <td>Menu Text <input type="text" name="imwb_videopress_theme_options[ravcatmenutxt]" value="<?php echo esc_attr( imwb_videopress_get_option('ravcatmenutxt') ); ?>" size="30"/> - Don't Show <input id="imwb_videopress_theme_options[ravcatmenu]" type="checkbox" name="imwb_videopress_theme_options[ravcatmenu]" value="Y" <?php echo imwb_videopress_get_option('ravcatmenu') == "Y" ? "checked='Yes'" : "" ?> /><br>
   			   Title Text&nbsp;&nbsp;&nbsp;<input type="text" name="imwb_videopress_theme_options[ravcatmenutitle]" value="<?php echo esc_attr( imwb_videopress_get_option('ravcatmenutitle') ); ?>" size="30"/>
   			</td>
   		 </tr>
   		 <tr><td class="label top"><?php _e( 'Most Viewed Videos Menu', 'imwb_videopress' ); ?></td>
   			 <td>Menu Text <input type="text" name="imwb_videopress_theme_options[mvvcatmenutxt]" value="<?php echo esc_attr( imwb_videopress_get_option('mvvcatmenutxt') ); ?>" size="30"/> - Don't Show <input id="imwb_videopress_theme_options[mvvcatmenu]" type="checkbox" name="imwb_videopress_theme_options[mvvcatmenu]" value="Y" <?php echo imwb_videopress_get_option('mvvcatmenu') == "Y" ? "checked='Yes'" : "" ?> /><br>
   			   Title Text&nbsp;&nbsp;&nbsp;<input type="text" name="imwb_videopress_theme_options[mvvcatmenutitle]" value="<?php echo esc_attr( imwb_videopress_get_option('mvvcatmenutitle') ); ?>" size="30"/>
   			</td>
   		 </tr>
   		 <tr><td class="label top"><?php _e( 'Top Rated Videos Menu', 'imwb_videopress' ); ?></td>
   			 <td>Menu Text <input type="text" name="imwb_videopress_theme_options[trvcatmenutxt]" value="<?php echo esc_attr( imwb_videopress_get_option('trvcatmenutxt') ); ?>" size="30"/> - Don't Show <input id="imwb_videopress_theme_options[trvcatmenu]" type="checkbox" name="imwb_videopress_theme_options[trvcatmenu]" value="Y" <?php echo imwb_videopress_get_option('trvcatmenu') == "Y" ? "checked='Yes'" : "" ?> /><br>
   			   Title Text&nbsp;&nbsp;&nbsp;<input type="text" name="imwb_videopress_theme_options[trvcatmenutitle]" value="<?php echo esc_attr( imwb_videopress_get_option('trvcatmenutitle') ); ?>" size="30"/>
   			</td>
   		 </tr>
   		 <tr><td class="label top"><?php _e( 'Trending Videos Menu', 'imwb_videopress' ); ?></td>
   		 	 <td>Menu Text <input type="text" name="imwb_videopress_theme_options[tdvcatmenutxt]" value="<?php echo esc_attr( imwb_videopress_get_option('tdvcatmenutxt') ); ?>" size="30"/> - Don't Show <input id="imwb_videopress_theme_options[tdvcatmenu]" type="checkbox" name="imwb_videopress_theme_options[tdvcatmenu]" value="Y" <?php echo imwb_videopress_get_option('tdvcatmenu') == "Y" ? "checked='Yes'" : "" ?> /><br>
   		 	   Title Text&nbsp;&nbsp;&nbsp;<input type="text" name="imwb_videopress_theme_options[tdvcatmenutitle]" value="<?php echo esc_attr( imwb_videopress_get_option('tdvcatmenutitle') ); ?>" size="30"/>
   		 	</td>
   		 </tr>
   		 <tr><td class="label top"><?php _e( 'Categories Drop Down Menu', 'imwb_videopress' ); ?></td>
   			 <td>Don't Show <input id="imwb_videopress_theme_options[othercatmenu]" type="checkbox" name="imwb_videopress_theme_options[othercatmenu]" value="Y" <?php echo imwb_videopress_get_option('othercatmenu') == "Y" ? "checked='Yes'" : "" ?> />
   			</td>
   		 </tr>
   		 <tr><td class="label top"><?php _e( 'Categories to Exclude from Menu', 'imwb_videopress' ); ?></td>
   			 <td><select size="7"  multiple="multiple"  style="width:340px; height:auto;" name="imwb_videopress_theme_options[excludecats][]" id="imwb_videopress_theme_options[excludecats]" >
   		<?php
   					$currentcats = explode(",", htmlspecialchars(imwb_videopress_get_option('excludecats')) );
   		         echo cvp_get_blog_categories(0, $currentcats);

   		?></select>   <br>
   		 <a href="javascript:void(0)" onclick="imwb_ms_unselectAll(document.getElementById('imwb_videopress_theme_options[excludecats]'))"><?php _e('Unselect All','imwb_videopress'); ?></a>
   			 </td>
   		 </tr>
   		 <tr><td  colspan="2" class="wide-label"><?php _e( 'Footer', 'imwb_videopress' ); ?></td></tr>
  		    <tr><td class="label"><?php _e( 'Hide Footer', 'imwb_videopress' ); ?></td>
   		   	 <td><input id="imwb_videopress_theme_options[hidefooter]" type="checkbox" name="imwb_videopress_theme_options[hidefooter]" value="Y" <?php echo imwb_videopress_get_option('hidefooter') == "Y" ? "checked='Yes'" : "" ?> />

   		   	</td>
   		 </tr>
   		 <tr><td class="label"><?php _e( 'Footer Area Background Color', 'imwb_videopress' ); ?></td>
   		  	 <td>
   		  	   <input class="color-input" type="text" name="imwb_videopress_theme_options[footerbgcol]" value="<?php echo esc_attr( imwb_videopress_get_option('footerbgcol') ); ?>"/>
   		  	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
   		  	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
   		  	</td>
   		 </tr>
   		 <tr><td class="label"><?php _e( 'Footer Area Border Color', 'imwb_videopress' ); ?></td>
   		 	 <td>
   		 	   <input class="color-input" type="text" name="imwb_videopress_theme_options[footerbdrcol]" value="<?php echo esc_attr( imwb_videopress_get_option('footerbdrcol') ); ?>"/>
   		 	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
   		 	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
   		 	</td>
   		 </tr>
   		</tbody>
         </table>

         <div class="wizzard-step-bar" data-rel-step="2"><?php _e( '2. Featured Video Rotator', 'imwb_videopress' ); ?></div>
          <table id="step2" class="widefat wizzard-step">
          <tbody>
           <tr class="desc">
            <td colspan="2"><div class="wizzard-step-stage"></div><div class="desc"><?php _e( 'Here you can control whether you want to use the featured video rotator and if so where you want to display it. You can also select how many videos to feature, in what order and of course also what you want the featured video rotator to look like. If you need help with any of this, please click on the button to watch the video tutorial', 'imwb_videopress' ); if($wizzardMode) _e( '<br><br>Click the "Next" button to proceed to the next step.', 'imwb_videopress' );?><div class="wizzard-watch-vid"><a href="<?php echo is_ssl() ? 'https' : 'http';?>://youtube.com/embed/X7n6r94fv2M" title="<?php _e( 'Click To Watch A Tutorial Video', 'imwb_videopress' ); ?>"><img src='<?php echo get_template_directory_uri();?>/images/wizard-watch-vid.png'></a></div></div></td>
           </tr>
           	<tr valign="top"><td class="label top"><?php _e( 'Show Rotator at the top of', 'imwb_videopress' ); ?></td>
           	 <td><input id="imwb_videopress_theme_options[showrotatorhp]" type="checkbox" name="imwb_videopress_theme_options[showrotatorhp]" value="Y" <?php echo imwb_videopress_get_option('showrotatorhp') == "Y" ? "checked='Yes'" : "" ?> /> Home Page&nbsp;&nbsp;<input id="imwb_videopress_theme_options[showrotatorsp]" type="checkbox" name="imwb_videopress_theme_options[showrotatorsp]" value="Y" <?php echo imwb_videopress_get_option('showrotatorsp') == "Y" ? "checked='Yes'" : "" ?> /> Single Posts&nbsp;&nbsp;<input id="imwb_videopress_theme_options[showrotatorpg]" type="checkbox" name="imwb_videopress_theme_options[showrotatorpg]" value="Y" <?php echo imwb_videopress_get_option('showrotatorpg') == "Y" ? "checked='Yes'" : "" ?> /> Pages&nbsp;&nbsp;<br><input id="imwb_videopress_theme_options[showrotatorap]" type="checkbox" name="imwb_videopress_theme_options[showrotatorap]" value="Y" <?php echo imwb_videopress_get_option('showrotatorap') == "Y" ? "checked='Yes'" : "" ?> /> Category, Tag, Archive & Search result pages&nbsp;&nbsp;

           	</td>
           	</tr>
            <td colspan="2" class="wide-label"><?php _e( 'Rotator row background use ', 'imwb_videopress' ); ?>
             <input class="inputToggle" data-ifsel-show-this=".fpbackground-val-c" type="radio" name="imwb_videopress_theme_options[fpbackground]" value="C" <?php echo imwb_videopress_get_option('fpbackground') == "C" ? "checked='Yes'" : "" ?> />
          <?php _e( ' color or ', 'imwb_videopress' ); ?>
             <input class="inputToggle" data-ifsel-show-this=".fpbackground-val-i" type="radio" name="imwb_videopress_theme_options[fpbackground]" value="I" <?php echo imwb_videopress_get_option('fpbackground') == "I" ? "checked='Yes'" : "" ?> />
          <?php _e( ' image.', 'imwb_videopress' ); ?>
          </td>
         </tr>
         </tbody>
         <tbody class="fpbackground-val-c">
         <tr><td class="label"><?php _e( 'Background Color', 'imwb_videopress' ); ?></td>
         	 <td>
         	   <input class="color-input" type="text" name="imwb_videopress_theme_options[fpbannerbgcol]" value="<?php echo esc_attr( imwb_videopress_get_option('fpbannerbgcol') ); ?>"/>
         	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
         	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
         	</td>
         </tr>
         </tbody>
         <tbody class="fpbackground-val-i">
         <tr valign="top"><td class="label"><?php _e( 'Select a background image', 'imwb_videopress' ); ?></td>
          <td> <input type="radio" name="imwb_videopress_theme_options[fpbgimage]" value="1" <?php echo imwb_videopress_get_option('fpbgimage') == "1" ? "checked='Yes'" : "" ?> /><img style="width: 90%;" src="<?php echo get_template_directory_uri(); ?>/images/videoPressHeader1.jpg">
          </td>
         </tr>
         <tr valign="top"><td class="label"></td>
          <td> <input type="radio" name="imwb_videopress_theme_options[fpbgimage]" value="2" <?php echo imwb_videopress_get_option('fpbgimage') == "2" ? "checked='Yes'" : "" ?> /><img style="width: 90%;" src="<?php echo get_template_directory_uri(); ?>/images/videoPressHeader2.jpg">
          </td>
         </tr>
         <tr valign="top"><td class="label"></td>
          <td> <input type="radio" name="imwb_videopress_theme_options[fpbgimage]" value="3" <?php echo imwb_videopress_get_option('fpbgimage') == "3" ? "checked='Yes'" : "" ?> /><img style="width: 90%;" src="<?php echo get_template_directory_uri(); ?>/images/videoPressHeader3.jpg">
          </td>
         </tr>
         <tr valign="top"><td class="label"></td>
          <td> <input type="radio" name="imwb_videopress_theme_options[fpbgimage]" value="4" <?php echo imwb_videopress_get_option('fpbgimage') == "4" ? "checked='Yes'" : "" ?> /><img style="width: 90%;" src="<?php echo get_template_directory_uri(); ?>/images/videoPressHeader4.jpg">
          </td>
         </tr>
         <tr valign="top"><td class="label"></td>
          <td> <input type="radio" name="imwb_videopress_theme_options[fpbgimage]" value="5" <?php echo imwb_videopress_get_option('fpbgimage') == "5" ? "checked='Yes'" : "" ?> /><img style="width: 90%;" src="<?php echo get_template_directory_uri(); ?>/images/videoPressHeader5.jpg">
          </td>
         </tr>
         <tr valign="top"><td class="label"></td>
          <td> <input type="radio" name="imwb_videopress_theme_options[fpbgimage]" value="6" <?php echo imwb_videopress_get_option('fpbgimage') == "6" ? "checked='Yes'" : "" ?> /><img style="width: 90%;" src="<?php echo get_template_directory_uri(); ?>/images/videoPressHeader6.jpg">
          </td>
         </tr>
         <tr valign="top"><td class="label top"><?php _e( 'Or upload a background image', 'imwb_videopress' ); ?><br><small><?php _e( 'Image Size [3072x325]', 'imwb_videopress' ); ?></small></td>
          <td> <input type="radio" name="imwb_videopress_theme_options[fpbgimage]" value="0" <?php echo imwb_videopress_get_option('fpbgimage') == "0" ? "checked='Yes'" : "" ?> />
          	<input id="imwb_videopress_theme_options[fpbannerbgimg]" class="regular-text" type="text" name="imwb_videopress_theme_options[fpbannerbgimg]" value="<?php esc_attr_e( imwb_videopress_get_option('fpbannerbgimg') ); ?>" />
          	<label class="description" for="imwb_videopress_theme_options[fpbannerbgimg]"></label><br>
          	<input style="margin-left: 23px;" type="file" name="fpbannerbg_img"  id="fpbannerbg_img" />
          </td>
         </tr>
         </tbody>
         <tbody>
         <tr valign="top"><td class="label"><?php _e( 'How many videos to feature', 'imwb_videopress' ); ?></td>
         	 <td>
         	   <input type="text" name="imwb_videopress_theme_options[postsperrotator]" value="<?php echo esc_attr( imwb_videopress_get_option('postsperrotator') ); ?>" size="5"/> <?php _e( 'posts', 'imwb_videopress' ); ?>
         	</td>
         </tr>

         <tr valign="top"><td class="label"><?php _e( 'Default Listing Order', 'imwb_videopress' ); ?></td>
         <td>
         	<select id="imwb_videopress_theme_options[fplistorder]" class="regular-text" type="text" name="imwb_videopress_theme_options[fplistorder]" />
         	<?php
         	 foreach ($listorder_options as $key => $value) {
                $selected = (imwb_videopress_get_option('fplistorder') == $key) ? " selected" : "";
         	    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
         	 }
         	?>
         	</select>
         </td>
         </tr>
         <tr valign="top"><td class="label top"><?php _e( 'Exclude Videos from the Categories', 'imwb_videopress' ); ?></td>
         	 <td><select size="10"  multiple="multiple"  style="width:340px; height:auto;" name="imwb_videopress_theme_options[fpexcludecats][]" id="imwb_videopress_theme_options[fpexcludecats]" >
         <?php
         			$currentcats = explode(",", htmlspecialchars(imwb_videopress_get_option('fpexcludecats')) );
                echo cvp_get_blog_categories(0, $currentcats);

         ?></select>   <br>
         <a href="javascript:void(0)" onclick="imwb_ms_unselectAll(document.getElementById('imwb_videopress_theme_options[fpexcludecats]'))"><?php _e('Unselect All','imwb_videopress'); ?></a>
         	 </td>
         </tr>
<?php /*
         <tr><td class="label"><?php _e( 'Caption Background Color', 'imwb_videopress' ); ?></td>
         	 <td>
         	   <input class="color-input" type="text" name="imwb_videopress_theme_options[fpcaptionbgcol]" value="<?php echo esc_attr( imwb_videopress_get_option('fpcaptionbgcol') ); ?>"/>
         	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
         	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
         	</td>
         </tr>
*/ ?>
         <tr valign="top"><td class="label"><?php _e( 'Video Title Color', 'imwb_videopress' ); ?></td>
         	 <td>
         	   <input class="color-input" type="text" name="imwb_videopress_theme_options[fptitlecol]" value="<?php echo esc_attr( imwb_videopress_get_option('fptitlecol') ); ?>"/>
         	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
         	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
         	   &nbsp;&nbsp;<?php _e( 'On Hover', 'imwb_videopress' ); ?> <input class="color-input" type="text" name="imwb_videopress_theme_options[fptitlehvrcol]" value="<?php echo esc_attr( imwb_videopress_get_option('fptitlehvrcol') ); ?>"/>
         	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
         	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
         	</td>
         </tr>
         </tbody>
         </table>

         <div class="wizzard-step-bar" data-rel-step="3"><?php _e( '3. Home Page Settings', 'imwb_videopress' ); ?></div>
          <table id="step3" class="widefat wizzard-step">
          <tbody>
           <tr class="desc">
            <td colspan="2"><div class="wizzard-step-stage"></div><div class="desc"><?php _e( 'Here you can customize the look of your home page and more specifically how your posts will look on your blog\'s home page.<br><br>There are quite a few settings for this step and if you need help with any of them, please watch the tutorial video for this step. Or you can simply use the default settings below.', 'imwb_videopress' ); if($wizzardMode) _e( '<br><br>Click the "Next" button to proceed to the next step.', 'imwb_videopress' );?><div class="wizzard-watch-vid"><a href="<?php echo is_ssl() ? 'https' : 'http';?>://youtube.com/embed/CWgeKkM4_fU" title="<?php _e( 'Click To Watch A Tutorial Video', 'imwb_videopress' ); ?>"><img src='<?php echo get_template_directory_uri();?>/images/wizard-watch-vid.png'></a></div></div></td>
           </tr>
           <tr valign="top"><td class="label"><?php _e( 'Background color', 'imwb_videopress' ); ?></td>
            <td>
              <input class="color-input" type="text" name="imwb_videopress_theme_options[backgroundcol]" value="#<?php echo esc_attr( get_theme_mod('background_color') ); ?>"/>
              <input type='button' class='pickcolor button-secondary' value='Select Color'>
              <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
           </td>
           </tr>
           <tr valign="top"><td class="label"><?php _e( 'Or upload a background image', 'imwb_videopress' ); ?></td>
           	<td>
           		<input type="file" name="background_img"  id="background_img" />
           	</td>
           </tr>
           <tr valign="top"><td class="label"><?php _e( 'Default Video Listing Order', 'imwb_videopress' ); ?></td>
           	<td>
           		<select id="imwb_videopress_theme_options[listorder]" class="regular-text" type="text" name="imwb_videopress_theme_options[listorder]" />
           		<?php
           		 foreach ($listorder_options as $key => $value) {
                     $selected = (imwb_videopress_get_option('listorder') == $key) ? " selected" : "";
           		    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
           		 }
           		?>
           		</select>
           	</td>
           </tr>
           	 <tr><td class="label"><?php _e( 'Post Background Color', 'imwb_videopress' ); ?></td>
           	 	 <td>
           	 	   <input class="color-input" type="text" name="imwb_videopress_theme_options[postcontentbgcol]" value="<?php echo esc_attr( imwb_videopress_get_option('postcontentbgcol') ); ?>"/>
           	 	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
           	 	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
           	 	</td>
           	 </tr>
           	<tr><td class="label"><?php _e( 'Post Border Color', 'imwb_videopress' ); ?></td>
           		 <td>
           		   <input class="color-input" type="text" name="imwb_videopress_theme_options[postcontentbdrcol]" value="<?php echo esc_attr( imwb_videopress_get_option('postcontentbdrcol') ); ?>"/>
           		   <input type='button' class='pickcolor button-secondary' value='Select Color'>
           		   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
           		</td>
           	</tr>
            <tr valign="top"><td class="label"><?php _e( 'Show Post Title', 'imwb_videopress' ); ?></td>
            	<td>
            		<select id="imwb_videopress_theme_options[showtitle]" class="regular-text" type="text" name="imwb_videopress_theme_options[showtitle]" />
             		<?php
             		 foreach ($yesno_options as $key => $value) {
                       $selected = (imwb_videopress_get_option('showtitle') == $key) ? " selected" : "";
             		    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
             		 }
             		?>
             		</select>
             	</td>
             </tr>
           	<tr valign="top"><td class="label top"><?php _e( 'Post Title Color', 'imwb_videopress' ); ?></td>
           		 <td>
           		   <input class="color-input" type="text" name="imwb_videopress_theme_options[posttitlecol]" value="<?php echo esc_attr( imwb_videopress_get_option('posttitlecol') ); ?>"/>
           		   <input type='button' class='pickcolor button-secondary' value='Select Color'>
           		   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
           		   &nbsp;&nbsp;<?php _e( 'On Hover', 'imwb_videopress' ); ?> <input class="color-input" type="text" name="imwb_videopress_theme_options[posttitlehvrcol]" value="<?php echo esc_attr( imwb_videopress_get_option('posttitlehvrcol') ); ?>"/>
           		   <input type='button' class='pickcolor button-secondary' value='Select Color'>
           		   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
           		</td>
           	</tr>
           	<tr valign="top"><td class="label top"><?php _e( 'Post Description', 'imwb_videopress' ); ?></td>
           		<td><input id="imwb_videopress_theme_options[postcontent]" type="radio" name="imwb_videopress_theme_options[postcontent]" value="N" <?php echo imwb_videopress_get_option('postcontent') == "N" ? "checked='Yes'" : "" ?> /> Don't show post description.<br class="clear">
           		<input id="imwb_videopress_theme_options[postcontent]" type="radio" name="imwb_videopress_theme_options[postcontent]" value="C" <?php echo imwb_videopress_get_option('postcontent') == "C" ? "checked='Yes'" : "" ?> /> Show the post excerptt - Show the first <input type="text" name="imwb_videopress_theme_options[postchars]" value="<?php echo imwb_videopress_get_option('postchars');?>" size=5 <?php echo imwb_videopress_get_option('postcontent') != "C" ? "readonly" : "" ?>> words of the post content.
           		</td>
           	</tr>
           	<tr valign="top"><td class="label"><?php _e( 'Post Description Text Color', 'imwb_videopress' ); ?></td>
           		 <td>
           		   <input class="color-input" type="text" name="imwb_videopress_theme_options[postdesccol]" value="<?php echo esc_attr( imwb_videopress_get_option('postdesccol') ); ?>"/>
           		   <input type='button' class='pickcolor button-secondary' value='Select Color'>
           		   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
           		</td>
           	</tr>
           	<tr valign="top"><td class="label top"><?php _e( 'Post Excerpt More Text', 'imwb_videopress' ); ?></td>
           		 <td>
           		   <input type="text" name="imwb_videopress_theme_options[postmoretext]" value="<?php echo esc_attr( imwb_videopress_get_option('postmoretext') ); ?>"/>
           		</td>
           	</tr>
           	<tr valign="top"><td class="label"><?php _e( 'Show Rating', 'imwb_videopress' ); ?></td>
           		<td>
           			<select id="imwb_videopress_theme_options[viewrating]" class="regular-text" type="text" name="imwb_videopress_theme_options[viewrating]" />
           			<?php
           			 foreach ($yesno_options as $key => $value) {
           	          $selected = (imwb_videopress_get_option('viewrating') == $key) ? " selected" : "";
           			    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
           			 }
           			?>
           			</select>
           		</td>
           	</tr>
           	<tr valign="top"><td class="label"><?php _e( 'Show View Count', 'imwb_videopress' ); ?></td>
           		<td>
           			<select id="imwb_videopress_theme_options[viewstats]" class="regular-text" type="text" name="imwb_videopress_theme_options[viewstats]" />
           			<?php
           			 foreach ($yesno_options as $key => $value) {
           	          $selected = (imwb_videopress_get_option('viewstats') == $key) ? " selected" : "";
           			    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
           			 }
           			?>
           			</select>
           		</td>
           	</tr>
             <tr valign="top"><td class="label"><?php _e( 'Show Comment Count', 'imwb_videopress' ); ?></td>
             	<td>
             		<select id="imwb_videopress_theme_options[commentstats]" class="regular-text" type="text" name="imwb_videopress_theme_options[commentstats]" />
             		<?php
             		 foreach ($yesno_options as $key => $value) {
                       $selected = (imwb_videopress_get_option('commentstats') == $key) ? " selected" : "";
             		    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
             		 }
             		?>
             		</select>
             	</td>
             </tr>
           </tbody>
           </table>

           <div class="wizzard-step-bar" data-rel-step="4"><?php _e( '4. Single Post Settings', 'imwb_videopress' ); ?></div>
            <table id="step4" class="widefat wizzard-step">
            <tbody>
             <tr class="desc">
              <td colspan="2"><div class="wizzard-step-stage"></div><div class="desc"><?php _e( 'Use the settings below to customize the look of your posts. There are a few settings for this step and if you need help with any of them, please watch the tutorial video for this step. Or you can simply use the default settings below.', 'imwb_videopress' ); if($wizzardMode) _e( '<br><br>Click the "Next" button to proceed to the next step.', 'imwb_videopress' );?><div class="wizzard-watch-vid"><a href="<?php echo is_ssl() ? 'https' : 'http';?>://youtube.com/embed/4z0cTA1_9PE" title="<?php _e( 'Click To Watch A Tutorial Video', 'imwb_videopress' ); ?>"><img src='<?php echo get_template_directory_uri();?>/images/wizard-watch-vid.png'></a></div></div></td>
             </tr>
             <tr valign="top"><td class="label"><?php _e( 'Background Color', 'imwb_videopress' ); ?></td>
             	 <td>
             	   <input class="color-input" type="text" name="imwb_videopress_theme_options[ptbgcol]" value="<?php echo esc_attr( imwb_videopress_get_option('ptbgcol') ); ?>"/>
              	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
              	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
             	</td>
             </tr>
             <tr><td class="label"><?php _e( 'Border Color', 'imwb_videopress' ); ?></td>
              	 <td>
              	   <input class="color-input" type="text" name="imwb_videopress_theme_options[ptcontentbdrcol]" value="<?php echo esc_attr( imwb_videopress_get_option('ptcontentbdrcol') ); ?>"/>
              	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
              	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
              	</td>
             </tr>
             <tr><td class="label"><?php _e( 'Hide Title', 'imwb_videopress' ); ?></td>
             	 <td><input id="imwb_videopress_theme_options[hidepttitle]" type="checkbox" name="imwb_videopress_theme_options[hidepttitle]" value="Y" <?php echo imwb_videopress_get_option('hidepttitle') == "Y" ? "checked='Yes'" : "" ?> />

             	</td>
             </tr>
             <tr><td class="label"><?php _e( 'Hide Uploaded Details', 'imwb_videopress' ); ?></td>
             	 <td><input id="imwb_videopress_theme_options[hideptdetails]" type="checkbox" name="imwb_videopress_theme_options[hideptdetails]" value="Y" <?php echo imwb_videopress_get_option('hideptdetails') == "Y" ? "checked='Yes'" : "" ?> />

             	</td>
             </tr>
             <tr><td class="label"><?php _e( 'Hide Rating', 'imwb_videopress' ); ?></td>
             		 <td><input id="imwb_videopress_theme_options[hideptrating]" type="checkbox" name="imwb_videopress_theme_options[hideptrating]" value="Y" <?php echo imwb_videopress_get_option('hideptrating') == "Y" ? "checked='Yes'" : "" ?> />

             		</td>
             </tr>
             <tr><td class="label"><?php _e( 'Hide Views Count', 'imwb_videopress' ); ?></td>
             		 <td><input id="imwb_videopress_theme_options[hideptviewstats]" type="checkbox" name="imwb_videopress_theme_options[hideptviewstats]" value="Y" <?php echo imwb_videopress_get_option('hideptviewstats') == "Y" ? "checked='Yes'" : "" ?> />

             		</td>
             </tr>
             <tr><td class="label"><?php _e( 'Hide Tags', 'imwb_videopress' ); ?></td>
             		 <td><input id="imwb_videopress_theme_options[hidepttagstats]" type="checkbox" name="imwb_videopress_theme_options[hidepttagstats]" value="Y" <?php echo imwb_videopress_get_option('hidepttagstats') == "Y" ? "checked='Yes'" : "" ?> />

             		</td>
             </tr>
             <tr><td class="label"><?php _e( 'Hide Categories', 'imwb_videopress' ); ?></td>
             		 <td><input id="imwb_videopress_theme_options[hideptcatstats]" type="checkbox" name="imwb_videopress_theme_options[hideptcatstats]" value="Y" <?php echo imwb_videopress_get_option('hideptcatstats') == "Y" ? "checked='Yes'" : "" ?> />

             		</td>
             </tr>
             <tr valign="top"><td class="label"><?php _e( 'Hide Related Videos', 'imwb_videopress' ); ?></td>
             	 <td><input id="imwb_videopress_theme_options[hideptrelated]" type="checkbox" name="imwb_videopress_theme_options[hideptrelated]" value="Y" <?php echo imwb_videopress_get_option('hideptrelated') == "Y" ? "checked='Yes'" : "" ?> />

             	 </td>
             </tr>
           </tbody>
           </table>

           <div class="wizzard-step-bar" data-rel-step="5"><?php _e( '5. Social Sharing on Single Post', 'imwb_videopress' ); ?></div>
            <table id="step5" class="widefat wizzard-step">
            <tbody>
             <tr class="desc">
              <td colspan="2"><div class="wizzard-step-stage"></div><div class="desc"><?php _e( 'Here you can select which social sharing options you want to display on your blog\'s single posts.<br><br>If you are unsure about any of these settings, please click the icon to watch the tutorial video.', 'imwb_videopress' ); if($wizzardMode) _e( '<br><br>Click the "Next" button to proceed to the next step.', 'imwb_videopress' );?><div class="wizzard-watch-vid"><a href="<?php echo is_ssl() ? 'https' : 'http';?>://youtube.com/embed/TnHMDItkjJA" title="<?php _e( 'Click To Watch A Tutorial Video', 'imwb_videopress' ); ?>"><img src='<?php echo get_template_directory_uri();?>/images/wizard-watch-vid.png'></a></div></div></td>
             </tr>
             <tr valign="top"><td class="label"><?php _e( 'Comments Type', 'imwb_videopress' ); ?></td>
             	<td>
             		<select id="imwb_videopress_theme_options[commenttype]" class="regular-text" type="text" name="imwb_videopress_theme_options[commenttype]" />
             		<?php
             		 foreach ($comments_options as $key => $value) {
                      $selected = (imwb_videopress_get_option('commenttype') == $key) ? " selected" : "";
             		    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
             		 }
             		?>
             		</select>
             	</td>
             </tr>
             <tr class="comment-type-fb" <?php echo (imwb_videopress_get_option('commenttype') == '0' || imwb_videopress_get_option('commenttype') == '3')? 'style="display: none;"' : ""; ?>><td class="label"><?php _e( 'Facebook App Id', 'imwb_videopress' ); ?></td>
             	 <td>
             	   <input type="text" name="imwb_videopress_theme_options[fbappid]" value="<?php echo esc_attr( imwb_videopress_get_option('fbappid') ); ?>" size="15"/>
             	</td>
             </tr>
             <tr class="comment-type-wp" <?php echo (imwb_videopress_get_option('commenttype') == '1' || imwb_videopress_get_option('commenttype') == '3') ? 'style="display: none;"' : ""; ?>><td class="label"><?php _e( 'Hide Wordpress Comments Timestamp', 'imwb_videopress' ); ?></td>
             		 <td><input id="imwb_videopress_theme_options[hideptcommenttime]" type="checkbox" name="imwb_videopress_theme_options[hideptcommenttime]" value="Y" <?php echo imwb_videopress_get_option('hideptcommenttime') == "Y" ? "checked='Yes'" : "" ?> />
             		</td>
             </tr>
             <tr><td class="label"><?php _e( 'Hide Social Buttons', 'imwb_videopress' ); ?></td>
              		 <td><input id="imwb_videopress_theme_options[hideptsocialbtns]" type="checkbox" name="imwb_videopress_theme_options[hideptsocialbtns]" value="Y" <?php echo imwb_videopress_get_option('hideptsocialbtns') == "Y" ? "checked='Yes'" : "" ?> />

              		</td>
             </tr>
      	    <tr valign="top"><td class="label"><?php _e( 'Social Sharing Buttons', 'imwb_videopress' ); ?></td>
      		   <td>
    <?php
    $shareoptions = explode(",", imwb_videopress_get_option('shareoptions'));
    ?>
      		<input id="imwb_videopress_theme_options[shareoptions]" type="checkbox" name="imwb_videopress_theme_options[shareoptions][]" value="F" <?php echo in_array("F", $shareoptions)  ? "checked='Yes'" : "" ?> />	<?php _e( 'Facebook', 'imwb_videopress' ); ?>&nbsp;&nbsp;<input id="imwb_videopress_theme_options[shareoptions]" type="checkbox" name="imwb_videopress_theme_options[shareoptions][]" value="T" <?php echo in_array("T", $shareoptions) ? "checked='Yes'" : "" ?> />	<?php _e( 'Twitter', 'imwb_videopress' ); ?>&nbsp;&nbsp;<input id="imwb_videopress_theme_options[shareoptions]" type="checkbox" name="imwb_videopress_theme_options[shareoptions][]" value="P" <?php echo in_array("P", $shareoptions) ? "checked='Yes'" : "" ?> />	<?php _e( 'Pinterest', 'imwb_videopress' ); ?>&nbsp;&nbsp;<input id="imwb_videopress_theme_options[shareoptions]" type="checkbox" name="imwb_videopress_theme_options[shareoptions][]" value="L" <?php echo in_array("L", $shareoptions) ? "checked='Yes'" : "" ?> />	<?php _e( 'LinkedIn', 'imwb_videopress' ); ?>&nbsp;&nbsp;<input id="imwb_videopress_theme_options[shareoptions]" type="checkbox" name="imwb_videopress_theme_options[shareoptions][]" value="G" <?php echo in_array("G", $shareoptions) ? "checked='Yes'" : "" ?> />	<?php _e( 'Google+', 'imwb_videopress' ); ?>&nbsp;&nbsp;<input id="imwb_videopress_theme_options[shareoptions]" type="checkbox" name="imwb_videopress_theme_options[shareoptions][]" value="B" <?php echo in_array("B", $shareoptions) ? "checked='Yes'" : "" ?> />	<?php _e( 'Tumblr', 'imwb_videopress' ); ?>&nbsp;&nbsp;<input id="imwb_videopress_theme_options[shareoptions]" type="checkbox" name="imwb_videopress_theme_options[shareoptions][]" value="R" <?php echo in_array("R", $shareoptions) ? "checked='Yes'" : "" ?> />	<?php _e( 'Reddit', 'imwb_videopress' ); ?>
    		   </td>
    		 </tr>
    		 <tr><td class="label"><?php _e( 'Use Stealth Like Versus Standard Like', 'imwb_videopress' ); ?></td>
    		   <td>
    		   	<select id="imwb_videopress_theme_options[sneakylikebtn]" class="regular-text" type="text" name="imwb_videopress_theme_options[sneakylikebtn]" />
    		   		<?php
    		   		 foreach ($yesno_options as $key => $value) {
    		           $selected = (imwb_videopress_get_option('sneakylikebtn') == $key) ? " selected" : "";
    		   		    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
    		   		 }
    		   		?>
    		   		</select>
    		   	</td>
    		 </tr>
         </tbody>
        </table>

        <div class="wizzard-step-bar" data-rel-step="6"><?php _e( '6. Page Settings', 'imwb_videopress' ); ?></div>
         <table id="step6" class="widefat wizzard-step">
         <tbody>
          <tr class="desc">
           <td colspan="2"><div class="wizzard-step-stage"></div><div class="desc"><?php _e( 'Use the settings below to customize the social sharing options and of your blog\'s pages.<br><br>If you need help with any of these settings, please watch the tutorial video for this step. Or you can simply use the default settings below.', 'imwb_videopress' ); if($wizzardMode) _e( '<br><br>Click the "Next" button to proceed to the next step.', 'imwb_videopress' );?><div class="wizzard-watch-vid"><a href="<?php echo is_ssl() ? 'https' : 'http';?>://youtube.com/embed/bUuQFdGaAAY" title="<?php _e( 'Click To Watch A Tutorial Video', 'imwb_videopress' ); ?>"><img src='<?php echo get_template_directory_uri();?>/images/wizard-watch-vid.png'></a></div></div></td>
          </tr>
          <tr><td class="label"><?php _e( 'Hide Title', 'imwb_videopress' ); ?></td>
          		 <td><input id="imwb_videopress_theme_options[hidepgtitle]" type="checkbox" name="imwb_videopress_theme_options[hidepgtitle]" value="Y" <?php echo imwb_videopress_get_option('hidepgtitle') == "Y" ? "checked='Yes'" : "" ?> />

          		</td>
          </tr>
          <tr><td class="label"><?php _e( 'Hide Created Details', 'imwb_videopress' ); ?></td>
          		 <td><input id="imwb_videopress_theme_options[hidepgdetails]" type="checkbox" name="imwb_videopress_theme_options[hidepgdetails]" value="Y" <?php echo imwb_videopress_get_option('hidepgdetails') == "Y" ? "checked='Yes'" : "" ?> />

          		</td>
          </tr>
          <tr><td class="label"><?php _e( 'Hide Comments', 'imwb_videopress' ); ?></td>
          		 <td><input id="imwb_videopress_theme_options[hidepgcomments]" type="checkbox" name="imwb_videopress_theme_options[hidepgcomments]" value="Y" <?php echo imwb_videopress_get_option('hidepgcomments') == "Y" ? "checked='Yes'" : "" ?> />

          		</td>
          </tr>
         </tbody>
        </table>

        <div class="wizzard-step-bar" data-rel-step="7"><?php _e( '7. Sidebar Configuration', 'imwb_videopress' ); ?></div>
         <table id="step7" class="widefat wizzard-step">
         <tbody>
          <tr class="desc">
           <td colspan="2"><div class="wizzard-step-stage"></div><div class="desc"><?php _e( 'Here you can customize the look of your blog\'s sidebars and choose where you want to display your sidebars.<br><br>For help with this and information on how to (later) add widgets to your sidebar, please watch the tutorial video.', 'imwb_videopress' ); if($wizzardMode) _e( '<br><br>Click the "Next" button to proceed to the next step.', 'imwb_videopress' );?><div class="wizzard-watch-vid"><a href="<?php echo is_ssl() ? 'https' : 'http';?>://youtube.com/embed/IEW9jTveJmM" title="<?php _e( 'Click To Watch A Tutorial Video', 'imwb_videopress' ); ?>"><img src='<?php echo get_template_directory_uri();?>/images/wizard-watch-vid.png'></a></div></div></td>
          </tr>
          <tr><td class="label"><?php _e( 'Sidebar Background Color', 'imwb_videopress' ); ?></td>
          	 <td>
          	   <input class="color-input" type="text" name="imwb_videopress_theme_options[homesidebarbgcol]" value="<?php echo esc_attr( imwb_videopress_get_option('homesidebarbgcol') ); ?>"/>
          	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
          	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
          	</td>
          </tr>
          <tr><td class="label"><?php _e( 'Sidebar Border Color', 'imwb_videopress' ); ?></td>
          	 <td>
          	   <input class="color-input" type="text" name="imwb_videopress_theme_options[homesidebarbdrcol]" value="<?php echo esc_attr( imwb_videopress_get_option('homesidebarbdrcol') ); ?>"/>
          	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
          	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
          	</td>
          </tr>
          <tr valign="top"><td class="label"><?php _e( 'Sidebar Text Color', 'imwb_videopress' ); ?></td>
          	 <td>
          	   <input class="color-input" type="text" name="imwb_videopress_theme_options[sidebartextcol]" value="<?php echo esc_attr( imwb_videopress_get_option('sidebartextcol') ); ?>"/>
          	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
          	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
          	</td>
          </tr>
          <tr><td class="label"><?php _e( 'Widget Title Background Color', 'imwb_videopress' ); ?></td>
          	 <td>
          	   <input class="color-input" type="text" name="imwb_videopress_theme_options[widgettitlebgcol]" value="<?php echo esc_attr( imwb_videopress_get_option('widgettitlebgcol') ); ?>"/>
          	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
          	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
          	</td>
          </tr>
          <tr><td class="label"><?php _e( 'Widget Title Text Color', 'imwb_videopress' ); ?></td>
          	 <td>
          	   <input class="color-input" type="text" name="imwb_videopress_theme_options[widgettitletxtcol]" value="<?php echo esc_attr( imwb_videopress_get_option('widgettitletxtcol') ); ?>"/>
          	   <input type='button' class='pickcolor button-secondary' value='Select Color'>
          	   <div style='z-index: 100; background:#eee; border:1px solid #ccc; position:absolute; display:none;'></div>
          	</td>
          </tr>
          <tr valign="top"><td class="label"><?php _e( 'Main Sidebar Widget', 'imwb_videopress' ); ?></td>
          	<td>
          		<select id="imwb_videopress_theme_options[homesidebar]" class="regular-text" type="text" name="imwb_videopress_theme_options[homesidebar]" />
          		<?php
          		 foreach ($sidebar_options as $key => $value) {
                    $selected = (imwb_videopress_get_option('homesidebar') == $key) ? " selected" : "";
          		    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
          		 }
          		?>
          		</select>
          	</td>
          </tr>
          <tr valign="top"><td class="label"><?php _e( 'Single Post Sidebar Widget', 'imwb_videopress' ); ?></td>
          	<td>
          		<select id="imwb_videopress_theme_options[postsidebar]" class="regular-text" type="text" name="imwb_videopress_theme_options[postsidebar]" />
          		<?php
          		 foreach ($sidebar_options as $key => $value) {
                    $selected = (imwb_videopress_get_option('postsidebar') == $key) ? " selected" : "";
          		    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
          		 }
          		?>
          		</select>
          	</td>
          </tr>
          <tr valign="top"><td class="label"><?php _e( 'Page Sidebar Widget', 'imwb_videopress' ); ?></td>
          	<td>
          		<select id="imwb_videopress_theme_options[pagesidebar]" class="regular-text" type="text" name="imwb_videopress_theme_options[pagesidebar]" />
          		<?php
          		 foreach ($sidebar_options as $key => $value) {
                    $selected = (imwb_videopress_get_option('pagesidebar') == $key) ? " selected" : "";
          		    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
          		 }
          		?>
          		</select>
          	</td>
          </tr>
         </tbody>
        </table>

        <div class="wizzard-step-bar" data-rel-step="8"><?php _e( '8. Video Options', 'imwb_videopress' ); ?></div>
         <table id="step8" class="widefat wizzard-step">
         <tbody>
          <tr class="desc">
           <td colspan="2"><div class="wizzard-step-stage"></div><div class="desc"><?php _e( 'Here you can customize how you would like the videos to look and operate on your blog.<br><br>For help with this and information on how to (later) add widgets to your sidebar, please watch the tutorial video.', 'imwb_videopress' ); if($wizzardMode) _e( '<br><br>Click the "Next" button to proceed to the next step.', 'imwb_videopress' );?><div class="wizzard-watch-vid"><a href="<?php echo is_ssl() ? 'https' : 'http';?>://youtube.com/embed/uX7g5OV8xps" title="<?php _e( 'Click To Watch A Tutorial Video', 'imwb_videopress' ); ?>"><img src='<?php echo get_template_directory_uri();?>/images/wizard-watch-vid.png'></a></div></div></td>
          </tr>
          <tr valign="top"><td class="label"><?php _e( 'Auto Generate Video Thumbnails', 'imwb_videopress' ); ?></td>
           <td>
           	<select id="imwb_videopress_theme_options[autogenthumbs]" class="regular-text" type="text" name="imwb_videopress_theme_options[autogenthumbs]" />
           	<?php
           	 foreach ($yesno_options as $key => $value) {
                  $selected = (imwb_videopress_get_option('autogenthumbs') == $key) ? " selected" : "";
           	    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
           	 }
           	?>
           	</select>
           </td>
          </tr>
          <tr valign="top"><td class="label"><?php _e( 'Save Video Thumbnails To Media Library', 'imwb_videopress' ); ?></td>
            <td>
            	<select id="imwb_videopress_theme_options[storethumbs]" class="regular-text" type="text" name="imwb_videopress_theme_options[storethumbs]" />
            	<?php
            	 foreach ($yesno_options as $key => $value) {
                   $selected = (imwb_videopress_get_option('storethumbs') == $key) ? " selected" : "";
            	    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
            	 }
            	?>
            	</select>
            </td>
          </tr>
          <tr valign="top"><td class="label"><?php _e( 'Autoplay Videos', 'imwb_videopress' ); ?></td>
            <td>
           	<select id="imwb_videopress_theme_options[autoplay]" class="regular-text" type="text" name="imwb_videopress_theme_options[autoplay]" />
            	<?php
            	 foreach ($yesno_options as $key => $value) {
                   $selected = (imwb_videopress_get_option('autoplay') == $key) ? " selected" : "";
            	    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
            	 }
            	?>
            	</select>
           </td>
         </tr>
         </tr>
      	<tr valign="top"><td class="label"><?php _e( 'Activate modest branding on YouTube Videos', 'imwb_videopress' ); ?></td>
		    <td>
		   	<select id="imwb_videopress_theme_options[ytmodestbrand]" class="regular-text" type="text" name="imwb_videopress_theme_options[ytmodestbrand]" />
		   	<?php
		   	 foreach ($yesno_options as $key => $value) {
		          $selected = (imwb_videopress_get_option('ytmodestbrand') == $key) ? " selected" : "";
		   	    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
		   	 }
		   	?>
		   	</select>
      	  </td>
      	</tr>
      	<tr><td class="label"><?php _e( 'When Clicking a Video Thumb Open Video in New Window', 'imwb_videopress' ); ?></td>
      		 <td><input id="imwb_videopress_theme_options[videothumbnw]" type="checkbox" name="imwb_videopress_theme_options[videothumbnw]" value="Y" <?php echo imwb_videopress_get_option('videothumbnw') == "Y" ? "checked='Yes'" : "" ?> />

      		</td>
      	</tr>
      	<tr valign="top"><td class="label"><?php _e( 'Generate Schema.org Video Markup', 'imwb_videopress' ); ?></td>
      	 <td>
      	 	<select id="imwb_videopress_theme_options[genschemaorg]" class="regular-text" type="text" name="imwb_videopress_theme_options[genschemaorg]" />
      	 	<?php
      	 	 foreach ($yesno_options as $key => $value) {
      	        $selected = (imwb_videopress_get_option('genschemaorg') == $key) ? " selected" : "";
      	 	    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
      	 	 }
      	 	?>
      	 	</select>
      	 </td>
      	</tr>
        </tbody>
       </table>

       <div class="wizzard-step-bar" data-rel-step="9"><?php _e( '9. Lead Capture & Follow Me (Lighbox) Settings', 'imwb_videopress' ); ?></div>
       <table id="step9" class="widefat wizzard-step">
         <tbody style="display: table-row-group;">
         <tr class="desc">
          <td colspan="2"><div class="wizzard-step-stage"></div><div class="desc"><?php _e( 'Congratulations - you have reached the final step in the setup wizard - well done!<br><br>Here you can configure your email lead capture and social following lightbox popups. There are quite a few settings for this step and if you need help with any of them, please watch the tutorial video now.', 'imwb_videopress' ); ?><div class="wizzard-watch-vid"><a href="<?php echo is_ssl() ? 'https' : 'http';?>:://youtube.com/embed/8aYVLvHx2OY" title="<?php _e( 'Click To Watch A Tutorial Video', 'imwb_videopress' ); ?>"><img src='<?php echo get_template_directory_uri();?>/images/wizard-watch-vid.png'></a></div></div></td>
         </tr>
           <tr valign="top"><td class="label"><?php _e( 'Use autoresponder API or optin form ', 'imwb_videopress' ); ?></td>
            <td><input id="imwb_videopress_theme_options[leadcapturearoption]" type="radio" name="imwb_videopress_theme_options[leadcapturearoption]" value="N" <?php echo imwb_videopress_get_option('leadcapturearoption') == 'N'  ? "checked='Yes'" : "" ?> />	<?php _e( 'No', 'imwb_videopress' ); ?>&nbsp;&nbsp;
              <input id="imwb_videopress_theme_options[leadcapturearoption]" type="radio" name="imwb_videopress_theme_options[leadcapturearoption]" value="A" <?php echo imwb_videopress_get_option('leadcapturearoption') == 'A'  ? "checked='Yes'" : "" ?> />	<?php _e( 'Aweber', 'imwb_videopress' ); ?>&nbsp;&nbsp;
              <input id="imwb_videopress_theme_options[leadcapturearoption]" type="radio" name="imwb_videopress_theme_options[leadcapturearoption]" value="G" <?php echo imwb_videopress_get_option('leadcapturearoption') == 'G'  ? "checked='Yes'" : "" ?> />	<?php _e( 'GetResponse', 'imwb_videopress' ); ?>&nbsp;&nbsp;
              <input id="imwb_videopress_theme_options[leadcapturearoption]" type="radio" name="imwb_videopress_theme_options[leadcapturearoption]" value="I" <?php echo imwb_videopress_get_option('leadcapturearoption') == 'I'  ? "checked='Yes'" : "" ?> />	<?php _e( 'iContact', 'imwb_videopress' ); ?>&nbsp;&nbsp;
              <input id="imwb_videopress_theme_options[leadcapturearoption]" type="radio" name="imwb_videopress_theme_options[leadcapturearoption]" value="M" <?php echo imwb_videopress_get_option('leadcapturearoption') == 'M'  ? "checked='Yes'" : "" ?> />	<?php _e( 'MailChimp', 'imwb_videopress' ); ?>&nbsp;&nbsp;
              <input id="imwb_videopress_theme_options[leadcapturearoption]" type="radio" name="imwb_videopress_theme_options[leadcapturearoption]" value="O" <?php echo imwb_videopress_get_option('leadcapturearoption') == 'O'  ? "checked='Yes'" : "" ?> />	<?php _e( 'Other', 'imwb_videopress' ); ?>&nbsp;&nbsp;
            </td>
           </tr>
           <tr class="ar-field<?php echo imwb_videopress_get_option('leadcapturearoption') == 'N' ? ' hidden' : '';?>" valign="top"><td class="label top"><?php _e( 'Lead capture form description', 'imwb_videopress' ); ?>
            </td>
           <td><textarea name="imwb_videopress_theme_options[leadcaptureardesc]" style="width:100%;" rows=5><?php echo imwb_videopress_get_option('leadcaptureardesc');?></textarea></td>
         </tr>
         <tr class="aweber-field <?php echo imwb_videopress_get_option('leadcapturearoption') != 'A' ? 'hidden' : '';?>" valign="top"><td class="label align-center" colspan="2"><b>Need an Aweber Account? <a href="https://imwealthbuilders.aweber.com" target="_blank">Click Here</a> to get one.</b>
          </td>
         </tr>
           <tr class="aweber-field <?php echo imwb_videopress_get_option('leadcapturearoption') != 'A' ? 'hidden' : '';?>" valign="top"><td class="label"><?php _e( 'Aweber authorization code:', 'imwb_videopress' ); ?><br><a href="https://auth.aweber.com/1.0/oauth/authorize_app/919ff255" target="_blank"><?php _e( 'Click here to get your authorization code. ', 'imwb_videopress' ); ?></a>
            </td>
            <td><?php if(imwb_videopress_get_option('aweber_auth_code') == '') { ?>
                <input type="text" name="imwb_videopress_theme_options[aweber_auth_code]" value="<?php echo esc_attr( imwb_videopress_get_option('aweber_auth_code') ); ?>" size="60"/><br>
                <?php _e( 'Once you have got your authorization code and entered it above. You then need to save options in order to select the list to use. ', 'imwb_videopress' ); ?>
               <?php } else { ?>
                  <input type="hidden" name="imwb_videopress_theme_options[aweber_auth_code]" value="<?php echo esc_attr( imwb_videopress_get_option('aweber_auth_code') ); ?>" />
               <?php
                  _e("You've successfully connected to your AWeber account!", 'imwb_videopress' );
               ?>
                  <input id="aweber-deauth" type="button" class="button-primary" value="<?php _e( 'Remove Connection', 'imwb_videopress' ); ?>" />
               <?php } ?>
            </td>
           </tr>
           <?php if(imwb_videopress_get_option('aweber_auth_code') != '')  { ?>
              <tr class="aweber-field <?php echo imwb_videopress_get_option('leadcapturearoption') != 'A' ? 'hidden' : '';?>" valign="top"><td class="label"><?php _e( 'AWeber list to subscribe to', 'imwb_videopress' ); ?>
               </td>
               <td>
           <?php
              try {
                      $aweber = new AWeberAPI(imwb_videopress_get_option('aweber_consumer_key'), imwb_videopress_get_option('aweber_consumer_secret'));
                      $account = $aweber->getAccount(imwb_videopress_get_option('aweber_access_key'), imwb_videopress_get_option('aweber_access_secret'));
                  } catch (AWeberException $e) {
                      $error_ = get_class($e);
                      $account = null;
                  }
                  if(is_null($account)) {
                      _e( 'The following error occured when trying to connect to Aweber:', 'imwb_videopress' );
                      echo ' '.$error_;
                  } else {
                     $lists = $account->lists;
                  ?>
                  <select name="imwb_videopress_theme_options[aweber_list]" id="imwb_videopress_theme_options[aweber_list]">
                    <?php foreach ($lists as $this_list) { ?>
                       <option value="<?php echo $this_list->id; ?>"<?php echo ($this_list->id == imwb_videopress_get_option('aweber_list')) ? ' selected="selected"' : ""; ?>><?php echo $this_list->name; ?></option>
                        <?php } ?>
                  </select>
           <?php } ?>
               </td>
              </tr>
           <?php } ?>
           <tr class="getresponse-field <?php echo imwb_videopress_get_option('leadcapturearoption') != 'G' ? 'hidden' : '';?>" valign="top"><td class="label align-center" colspan="2"><b>Need a GetResponse Account? <a href="https://www.getresponse.com/index/imwb" target="_blank">Click Here</a> to get one.</b>
            </td>
           </tr>
           <tr class="getresponse-field <?php echo imwb_videopress_get_option('leadcapturearoption') != 'G' ? 'hidden' : '';?>" valign="top"><td class="label"><?php _e( 'GetResponse API Key', 'imwb_videopress' ); ?><br><small><?php _e( 'Get it from', 'imwb_videopress' ); ?> <a href="https://app.getresponse.com/my_api_key.html" target="_blank"><?php _e( 'my account', 'imwb_videopress' ); ?></a> <?php _e( 'section after logging to your GetResponse account.', 'imwb_videopress' ); ?></small>
            </td>
            <td>
                <input type="text" name="imwb_videopress_theme_options[getresponse_api_key]" value="<?php echo esc_attr( imwb_videopress_get_option('getresponse_api_key') ); ?>" size="60"/>
            </td>
           </tr>
           <tr class="getresponse-field <?php echo imwb_videopress_get_option('leadcapturearoption') != 'G' ? 'hidden' : '';?>" valign="top"><td class="label"><?php _e( 'GetResponse Campaign to subscribe to', 'imwb_videopress' ); ?>
            </td>
            <td>
                 <?php if(imwb_videopress_get_option('getresponse_api_key') != '') {
                 # initialize JSON-RPC client
                 $GR_client = new jsonRPCClient('http://api2.getresponse.com');
                 try {
                    $GR_campaigns = $GR_client->get_campaigns(imwb_videopress_get_option('getresponse_api_key'));
                 ?>
                  <select id="imwb_videopress_theme_options[getresponse_campaign]" class="regular-text" type="text" name="imwb_videopress_theme_options[getresponse_campaign]" />
                      <?php
                       foreach ($GR_campaigns as $campaign_id => $GR_campaign) {
                          $selected = (imwb_videopress_get_option('getresponse_campaign') == $campaign_id) ? " selected" : "";
                          echo "<option value='{$campaign_id}' {$selected}>".$GR_campaign[name]."</option>";
                       }
                      ?>
                  </select>
             <?php
                 } catch (Exception $e) {
                    echo 'GetResponse API Error: '.$e->getMessage();
                 }
             ?>
             <?php } else { ?>
             <?php _e( 'You will need to enter your API Key then save options to gain access to the list of campaigns', 'imwb_videopress' ); ?>
             <?php } ?>
            </td>
           </tr>
           <tr class="arformurl-field <?php echo strpos('M', imwb_videopress_get_option('leadcapturearoption')) === false ? 'hidden' : '';?>" valign="top"><td class="label"><?php _e( 'HTML/Subscribe Form URL', 'imwb_videopress' ); ?><br><b>OR</b>
            </td>
            <td><input type="text" id="imwb_videopress_theme_options[ar_formurl]" class="regular-text" name="imwb_videopress_theme_options[ar_formurl]" value="<?php echo imwb_videopress_get_option('ar_formurl');?>" size="100">
            </td>
           </tr>
           <tr class="arformoth-field <?php echo strpos('O', imwb_videopress_get_option('leadcapturearoption')) === false ? 'hidden' : '';?>" valign="top"><td class="label"><?php _e( 'Enter input field name for the email input', 'imwb_videopress' ); ?>
             </td>
             <td><input type="text" id="imwb_videopress_theme_options[ar_formfldemail]" class="regular-text" name="imwb_videopress_theme_options[ar_formfldemail]" value="<?php echo imwb_videopress_get_option('ar_formfldemail');?>" size="100">
             </td>
           </tr>
           <tr class="arformoth-field <?php echo strpos('O', imwb_videopress_get_option('leadcapturearoption')) === false ? 'hidden' : '';?>" valign="top"><td class="label"><?php _e( 'Enter input field name for the name input', 'imwb_videopress' ); ?>
             </td>
             <td><input type="text" id="imwb_videopress_theme_options[ar_formfldname]" class="regular-text" name="imwb_videopress_theme_options[ar_formfldname]" value="<?php echo imwb_videopress_get_option('ar_formfldname');?>" size="100">
             </td>
           </tr>
           <tr class="arform-field <?php echo strpos('IMO', imwb_videopress_get_option('leadcapturearoption')) === false ? 'hidden' : '';?>" valign="top"><td class="label top"><?php _e( 'HTML Sign-up form', 'imwb_videopress' ); ?>
             </td>
             <td><textarea id="imwb_videopress_theme_options[ar_form]" class="regular-text" name="imwb_videopress_theme_options[ar_form]" cols=60 rows=10><?php echo imwb_videopress_get_option('ar_form');?></textarea>
            </td>
           </tr>
           <tr valign="top"><td class="label"><?php _e( 'Enter URL to like on Facebook', 'imwb_videopress' ); ?></td>
             <td><input type="text" name="imwb_videopress_theme_options[leadcapturefburl]" value="<?php echo esc_attr( imwb_videopress_get_option('leadcapturefburl') ); ?>" size="50"/><small><?php _e( ' - Leave blank if not required', 'imwb_videopress' ); ?></small>
            </td>
           </tr>
           <tr valign="top"><td class="label"><?php _e( 'Enter Pinterest user URL to follow', 'imwb_videopress' ); ?></td>
            <td><input type="text" name="imwb_videopress_theme_options[leadcapturepinbd]" value="<?php echo esc_attr( imwb_videopress_get_option('leadcapturepinbd') ); ?>" size="50"/><small><?php _e( ' - Leave blank if not required', 'imwb_videopress' ); ?></small>
            </td>
           </tr>
           <tr valign="top"><td class="label"><?php _e( 'Enter Tumblr Blog Name to follow', 'imwb_videopress' ); ?></td>
            <td><input type="text" name="imwb_videopress_theme_options[leadcapturetumblr]" value="<?php echo esc_attr( imwb_videopress_get_option('leadcapturetumblr') ); ?>" size="30"/><small><?php _e( ' - Leave blank if not required', 'imwb_videopress' ); ?></small>
            </td>
           </tr>
           <tr valign="top"><td class="label"><?php _e( 'Show Lightbox', 'imwb_videopress' ); ?></td>
            <td><input class="inputToggle" data-ifsel-show-this=".leadcaptureshow-val-p" type="radio" name="imwb_videopress_theme_options[leadcaptureshow]" value="P" <?php echo imwb_videopress_get_option('leadcaptureshow') == "P" ? "checked='Yes'" : "" ?> /><?php _e( 'On page load', 'imwb_videopress' ); ?>&nbsp;&nbsp;
              <input class="inputToggle" data-ifsel-show-this=".leadcaptureshow-val-l" type="radio" name="imwb_videopress_theme_options[leadcaptureshow]" value="L" <?php echo imwb_videopress_get_option('leadcaptureshow') == "L" ? "checked='Yes'" : "" ?> /><?php _e( 'When leaving site', 'imwb_videopress' ); ?>
            </td>
           </tr>
          </tbody>
          <tbody class="leadcaptureshow-val-p">
           <tr><td class="label"><?php _e( 'How many seconds before showing', 'imwb_videopress' ); ?></td>
           	 <td>
           	   <input type="text" name="imwb_videopress_theme_options[leadcaptureshowdelay]" value="<?php echo esc_attr( imwb_videopress_get_option('leadcaptureshowdelay') ); ?>" size="5"/>
           	</td>
           </tr>
          </tbody>
          <tbody>
           <tr valign="top"><td class="label"><?php _e( 'When closed days before shown again', 'imwb_videopress' ); ?><br><small><?php _e( ' 0 = never', 'imwb_videopress' ); ?></small></td>
            <td><input type="text" name="imwb_videopress_theme_options[leadcapturecloseddays]" value="<?php echo esc_attr( imwb_videopress_get_option('leadcapturecloseddays') ); ?>" size="5"/><a class="button-secondary" id="imwb_videopressClearCookie">Clear Cookie</a>
            </td>
           </tr>
        </tbody>
       </table>

       <div class="wizzard-step-bar" data-rel-step="10"><?php _e( '10. Advanced Options', 'imwb_videopress' ); ?></div>
       <table id="step10" class="widefat non-wizzard-step">
         <tbody style="display: table-row-group;">
         <tr class="desc">
          <td colspan="2"><div class="wizzard-step-stage"></div><div class="desc"><?php _e( 'In this optional final step you can further customize the look of your site with some of our advanced options.<br><br>Please watch the tutorial video before you start changing any of the settings below.', 'imwb_videopress' ); ?><div class="wizzard-watch-vid"><a href="<?php echo is_ssl() ? 'https' : 'http';?>://youtube.com/embed/SB8ENpXj7Cc" title="<?php _e( 'Click To Watch A Tutorial Video', 'imwb_videopress' ); ?>"><img src='<?php echo get_template_directory_uri();?>/images/wizard-watch-vid.png'></a></div></div></td>
         </tr>
			<tr valign="top"><td class="label top"><?php _e( 'Favicon', 'imwb_videopress' ); ?></td>
				<td>
					<input id="imwb_videopress_theme_options[faviconurl]" class="regular-text" type="text" name="imwb_videopress_theme_options[faviconurl]" value="<?php esc_attr_e( imwb_videopress_get_option('faviconurl') ); ?>" />
					<label class="description" for="imwb_videopress_theme_options[faviconurl]"><?php _e( 'Favicon url [16x16]', 'imwb_videopress' ); ?></label><br>
					<input type="file" name="favicon_img"  id="favicon_img" />
				</td>
			</tr>
			<tr><td class="label"><?php _e( 'Hide Search Form', 'imwb_videopress' ); ?></td>
				 <td><input id="imwb_videopress_theme_options[hidesearch]" type="checkbox" name="imwb_videopress_theme_options[hidesearch]" value="Y" <?php echo imwb_videopress_get_option('hidesearch') == "Y" ? "checked='Yes'" : "" ?> />

				</td>
			</tr>
         <tr><td class="label"><?php _e( 'Default Search Field Text', 'imwb_videopress' ); ?></td>
     	    <td><input type="text" name="imwb_videopress_theme_options[searchtext]" value="<?php echo esc_attr( imwb_videopress_get_option('searchtext') ); ?>" size="30"/>
     	    </td>
        </tr>
   	  <tr valign="top"><td class="heading" colspan="2"><?php _e( 'Additional Header Scripts/Styles', 'imwb_videopress' ); ?></td></tr>
   	  <tr valign="top"><td colspan="2"><?php _e( 'Use this section to place additional scripts and/or CSS styles into the <head> section of the theme. Whatever you put here is placed exactly into the code, so be careful with the syntax as it could adversely effect your site.', 'imwb_videopress' ); ?><br><textarea name="imwb_videopress_theme_options[headerscripts]" style="width:100%;" rows=10><?php echo imwb_videopress_get_option('headerscripts');?></textarea></td>
   	  </tr>
   	  <tr valign="top"><td class="heading" colspan="2"><?php _e( 'Additional Home Page Scripts/HTML/Text', 'imwb_videopress' ); ?></td></tr>
   	  <tr valign="top"><td colspan="2"><?php _e( 'Use this section to place additional scripts and/or HTML/Text that will go on the home page after the page navigation. Whatever you put here is placed exactly into the page, so be careful with the syntax as it could adversely effect your site.', 'imwb_videopress' ); ?><br><textarea name="imwb_videopress_theme_options[homepagescripts]" style="width:100%;" rows=10><?php echo imwb_videopress_get_option('homepagescripts');?></textarea></td>
   	  </tr>
       </tbody>
		</table>

      <div id="button-panel" class="clearfix">
       <input id="wizzard-prev" type="button" class="button-primary" value="Prev">
        <?php if ($wizzardMode) { ?>
           <input type="submit" class="button-secondary" value="<?php _e( 'Save', 'imwb_videopress' ); ?>" />
        <?php } else {?>
           <input type="submit" class="button-primary" value="<?php _e( 'Save Options', 'imwb_videopress' ); ?>" />
        <?php } ?>
        <input id="wizzard-next" type="button" class="button-primary" value="Next">
            </div>
		</form>
   	<iframe src="https://imwealthbuilders.com/wp_squeeze/promote.php?aid=0" width="815px" height="800px"></iframe>
	</div>
  </div>
	<?php
}

/**
 * Sanitize and validate input. Accepts an array, return a sanitized array.
 */

function imwb_videopress_theme_options_validate( $input ) {
   $output = imwb_videopress_get_default_theme_options();
   $output['showrotatorhp'] = 'N';
   $output['showrotatorap'] = 'N';
   $output['showrotatorsp'] = 'N';
   $output['showrotatorpg'] = 'N';
   $output['shareoptions'] = '';


   foreach ($input as $key => $value) {
      if($key == "postchars")
         $input[$key] = is_numeric($value) ? $value : 35;
      else if($key == "excludepages")
         $input[$key] = implode(',', $value);
      else if($key == "excludecats")
         $input[$key] = implode(',', $value);
      else if($key == "fpexcludecats")
         $input[$key] = implode(',', $value);
      else if($key == "shareoptions")
         $input[$key] = implode(',', $value);

		$output[$key] = trim($input[$key]);
	}

	$output['aweber_consumer_key'] = imwb_videopress_get_option('aweber_consumer_key');
	$output['aweber_consumer_secret'] = imwb_videopress_get_option('aweber_consumer_secret');
	$output['aweber_access_key'] = imwb_videopress_get_option('aweber_access_key');
	$output['aweber_access_secret'] = imwb_videopress_get_option('aweber_access_secret');

  	return $output;
 }

function imwb_videopress_theme_options_take_action() {

   if ( empty($_POST) )
   	return;

   // See if were saving theme options
   if(isset($_REQUEST['action']) && $_REQUEST['action'] == 'update') {


      // Deal with file uploads
      // Rotator Custom Background Image
      if ((($_FILES["fpbannerbg_img"]["type"] == "image/gif")
        || ($_FILES["fpbannerbg_img"]["type"] == "image/jpeg")
        || ($_FILES["fpbannerbg_img"]["type"] == "image/png")
        || ($_FILES["fpbannerbg_img"]["type"] == "image/jpeg")
        || ($_FILES["fpbannerbg_img"]["type"] == "image/pjpeg")
        || ($_FILES["fpbannerbg_img"]["type"] == "image/x-icon"))
        && ($_FILES["fpbannerbg_img"]["size"] > 0) &&  ($_FILES["fpbannerbg_img"]["error"] == 0))
      {
      	  $path = wp_upload_dir();
      	  if( !file_exists(  $path['path'] ) )
      	  {
      			mkdir(  $path['path'] );
      	  }
      	  $logopath=  $path['path'] . "/" . $_FILES["fpbannerbg_img"]["name"];
      	  if( file_exists(  $logopath ) )
      	  {
      			unlink( $logopath);
      	  }

           move_uploaded_file( $_FILES["fpbannerbg_img"]["tmp_name"],  $logopath);
      	  $_REQUEST['imwb_videopress_theme_options']['fpbannerbgimg'] =  $path['url'] . "/" . $_FILES["fpbannerbg_img"]["name"] ;
      }

      // favicon
      if ((($_FILES["favicon_img"]["type"] == "image/gif")
        || ($_FILES["favicon_img"]["type"] == "image/jpeg")
        || ($_FILES["favicon_img"]["type"] == "image/png")
        || ($_FILES["favicon_img"]["type"] == "image/jpeg")
        || ($_FILES["favicon_img"]["type"] == "image/pjpeg")
        || ($_FILES["favicon_img"]["type"] == "image/x-icon"))
        && ($_FILES["favicon_img"]["size"] > 0) &&  ($_FILES["favicon_img"]["error"] == 0))
      {
      	  $path = wp_upload_dir();
      	  if( !file_exists(  $path['path'] ) )
      	  {
      			mkdir(  $path['path'] );
      	  }
      	  $logopath=  $path['path'] . "/" . $_FILES["favicon_img"]["name"];
      	  if( file_exists(  $logopath ) )
      	  {
      			unlink( $logopath);
      	  }

           move_uploaded_file( $_FILES["favicon_img"]["tmp_name"],  $logopath);
      	  $_REQUEST['imwb_videopress_theme_options']['faviconurl'] =  $path['url'] . "/" . $_FILES["favicon_img"]["name"] ;
     }

      // Save theme options
      $_REQUEST['imwb_videopress_theme_options']['wizzardstep'] = $_REQUEST['wizzardstep'];

      $updatedOptions = imwb_videopress_theme_options_validate($_REQUEST['imwb_videopress_theme_options']);

      if(isset($_REQUEST['aweber-auth']) && $_REQUEST['aweber-auth'] == 'deauth') {
         $updatedOptions['aweber_auth_code'] = "";
         $updatedOptions['aweber_consumer_key'] = "";
         $updatedOptions['aweber_consumer_secret'] = "";
         $updatedOptions['aweber_access_key'] = "";
         $updatedOptions['aweber_access_secret'] = "";
         $updatedOptions['aweber_list'] = "";

      } else if($updatedOptions['aweber_auth_code'] != '' && $updatedOptions['aweber_consumer_key'] == '' && imwb_videopress_get_option('aweber_consumer_secret')    == '') {

         try {
            list($consumer_key, $consumer_secret, $access_key, $access_secret) = AWeberAPI::getDataFromAweberID($updatedOptions['aweber_auth_code']);
         } catch (AWeberAPIException $exc) {
             list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
             $updatedOptions['aweber_auth_code'] = '';
             # make error messages customer friendly.
             $descr = $exc->description;
             $descr = preg_replace('/http.*$/i', '', $descr);     # strip labs.aweber.com documentation url from error message
             $descr = preg_replace('/[\.\!:]+.*$/i', '', $descr); # strip anything following a . : or ! character
             $aweber_error_code = " ($descr)";
         } catch (AWeberOAuthDataMissing $exc) {
            $updatedOptions['aweber_auth_code'] = '';
             list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
         } catch (AWeberException $exc) {
            $updatedOptions['aweber_auth_code'] = '';
             list($consumer_key, $consumer_secret, $access_key, $access_secret) = null;
         }

         $updatedOptions['aweber_consumer_key'] = $consumer_key;
         $updatedOptions['aweber_consumer_secret'] =$consumer_secret;
         $updatedOptions['aweber_access_key'] = $access_key;
         $updatedOptions['aweber_access_secret'] = $access_secret;
      }

      if($updatedOptions['leadcapturearoption'] == 'I' || $updatedOptions['leadcapturearoption'] == 'M' || $updatedOptions['leadcapturearoption'] == 'O') {

         $new_ar['error'] = '';

         if(($updatedOptions['leadcapturearoption'] == 'M')
             && $updatedOptions['ar_formurl'] != "") {
            $response = wp_remote_get(urldecode($updatedOptions['ar_formurl']));
            if( is_wp_error( $response ) )
               $new_ar['error'] = $response->get_error_message();

            $parser = new HtmlFormParser( urldecode($response['body']) );
         }
         else
            $parser = new HtmlFormParser( urldecode(stripslashes($updatedOptions['ar_form'])) );

      	$result = $parser->parseForms();
      	$result = $result[0];

         if($updatedOptions['leadcapturearoption'] == 'I') {
         	$new_ar['name'] = 'icontact';
       		$new_ar['action'] = $result['form_data']['action'];
         	foreach ($result['form_elemets'] as $key => $value) {
               if($key == 'fields_fname') $new_ar['form_data'][$key] = '%%FNAME%%';
               else if($key == 'fields_lname') $new_ar['form_data'][$key] = '%%LNAME%%';
               else if($key == 'fields_email') $new_ar['form_data'][$key] = '%%EMAIL%%';
               else $new_ar['form_data'][$key] = $value['value'];
         	}
            foreach ($result['buttons'] as $key => $value) {
               if($value['type'] == 'submit') $new_ar['form_data'][$value['type']] = $value['value'];
            }
         }
         else if($updatedOptions['leadcapturearoption'] == 'M') {
         	$new_ar['name'] = 'mailchimp';
         	$new_ar['action'] = $result['form_data']['action'];
         	foreach ($result['form_elemets'] as $key => $value) {
               if($key == 'EMAIL')	$new_ar['form_data'][$key] = '%%EMAIL%%';
               else if($key == 'MERGE0') $new_ar['form_data'][$key] = '%%EMAIL%%';
               else if($key == 'MERGE1') $new_ar['form_data'][$key] = '%%FNAME%%';
               else if($key == 'MERGE2') $new_ar['form_data'][$key] = '%%LNAME%%';
               else $new_ar['form_data'][$key] = $value['value'];
         	}
            foreach ($result['buttons'] as $key => $value) {
               if($value['type'] == 'submit') $new_ar['form_data'][$value['type']] = $value['value'];
            }
         }
         else if($updatedOptions['leadcapturearoption'] == 'O') {
         	$new_ar['name'] = 'otherar';
         	$new_ar['action'] = $result['form_data']['action'];
         	foreach ($result['form_elemets'] as $key => $value) {
              if($key == $updatedOptions['ar_formfldemail']) $new_ar['form_data'][$key] = '%%EMAIL%%';
              else if($key == $updatedOptions['ar_formfldname']) $new_ar['form_data'][$key] = '%%NAME%%';
              else $new_ar['form_data'][$key] = $value['value'];
         	}
            foreach ($result['buttons'] as $key => $value) {
               if($value['type'] == 'submit') $new_ar['form_data'][$value['type']] = $value['value'];
            }
         }

      	update_option('imwb_videopress_theme_ar_data', $new_ar);
      }

      // Header Image
      if(isset($_FILES["header_img"])) {
         $uploaded_file = $_FILES['header_img'];
         $wp_filetype = wp_check_filetype_and_ext( $uploaded_file['tmp_name'], $uploaded_file['name'], false );
       	if ( wp_match_mime_types( 'image', $wp_filetype['type'] ) ) {
            $overrides = array('test_form' => false);
      		$file = wp_handle_upload($uploaded_file, $overrides);

      		if (!isset($file['error']) ) {

         		$url = $file['url'];
         		$type = $file['type'];
         		$file = $file['file'];
         		$filename = basename($file);

         		// Construct the object array
         		$object = array(
         			'post_title'     => $filename,
         			'post_content'   => $url,
         			'post_mime_type' => $type,
         			'guid'           => $url,
         			'context'        => 'custom-header'
         		);

         		// Save the data
         		$attachment_id = wp_insert_attachment( $object, $file );

               list( $img_width, $img_height, $type, $attr ) = getimagesize( $file );
               $width = get_theme_support( 'custom-header', 'width' );
               $height = $img_height;

               if($img_width <= $width) {
                  wp_update_attachment_metadata( $attachment_id, wp_generate_attachment_metadata( $attachment_id, $file ) );
                  $width = $img_width;
               }
               else {
         			$oitar = $img_width / $width;
         			$cropped = wp_crop_image($attachment_id, 0, 0, $img_width, $img_height, $width, $img_height / $oitar, false, str_replace(basename($file), 'midsize-'.basename($file), $file));
         			if ( ! $cropped || is_wp_error( $cropped ) )
         				wp_die( __( 'Image could not be processed. Please go back and try again.', 'imwb_videopress' ), __( 'Image Processing Error', 'imwb_videopress' ) );

         			$cropped = apply_filters('wp_create_file_in_uploads', $cropped, $attachment_id); // For replication

         			$url = str_replace(basename($url), basename($cropped), $url);
         			$height = $img_height / $oitar;

         			// Construct the object array
   					$object = array(
   						'ID' => $attachment_id,
   						'post_title' => basename($cropped),
   						'post_content' => $url,
   						'post_mime_type' => $type,
   						'guid' => $url,
   						'context' => 'custom-header'
   					);

   					// Update the attachment
   					$attachment_id = wp_insert_attachment( $object, $cropped );
   					wp_update_attachment_metadata( $attachment_id, wp_generate_attachment_metadata( $attachment_id, $cropped ) );

               }

      			$choice['url'] = esc_url_raw( $url );

      			$header_image_data = (object) array(
      				'attachment_id' => $attachment_id,
      				'url'           => $choice['url'],
      				'thumbnail_url' => $choice['url'],
      				'height'        => $height,
      				'width'         => $width,
      			);

      			update_post_meta( $attachment_id, '_wp_attachment_is_custom_header', get_stylesheet() );
      			set_theme_mod( 'header_image', $choice['url'] );
      			set_theme_mod( 'header_image_data', $header_image_data );

					do_action('wp_create_file_in_uploads', $file, $attachment_id); // For replication

					set_theme_mod( 'header_textcolor', 'blank' );

         	}
         }
      }

      // Background Image
      if(isset($_FILES["background_img"])) {
         $uploaded_file = $_FILES['background_img'];
         $wp_filetype = wp_check_filetype_and_ext( $uploaded_file['tmp_name'], $uploaded_file['name'], false );
         if ( wp_match_mime_types( 'image', $wp_filetype['type'] ) ) {
            $overrides = array('test_form' => false);
      		$file = wp_handle_upload($uploaded_file, $overrides);

      		if (!isset($file['error']) ) {

         		$url = $file['url'];
         		$type = $file['type'];
         		$file = $file['file'];
         		$filename = basename($file);

         		// Construct the object array
         		$object = array(
         			'post_title' => $filename,
         			'post_content' => $url,
         			'post_mime_type' => $type,
         			'guid' => $url,
         			'context' => 'custom-background'
         		);

         		// Save the data
         		$id = wp_insert_attachment($object, $file);

         		// Add the meta-data
         		wp_update_attachment_metadata( $id, wp_generate_attachment_metadata( $id, $file ) );
         		update_post_meta( $id, '_wp_attachment_is_custom_background', get_option('stylesheet' ) );

         		set_theme_mod('background_image', esc_url_raw($url));

         		$thumbnail = wp_get_attachment_image_src( $id, 'thumbnail' );
         		set_theme_mod('background_image_thumb', esc_url_raw( $thumbnail[0] ) );

         		do_action('wp_create_file_in_uploads', $file, $id); // For replication
            }
         }
      }

      // Update theme options
      $_REQUEST['imwb_videopress_theme_options']['backgroundcol'] = str_replace( '#', '', $_REQUEST['imwb_videopress_theme_options']['backgroundcol'] );
      $color = preg_replace('/[^0-9a-fA-F]/', '', $_REQUEST['imwb_videopress_theme_options']['backgroundcol']);
      set_theme_mod('background_color', $color);
      unset($_REQUEST['imwb_videopress_theme_options']['backgroundcol']);

      if ($_REQUEST['imwb_videopress_theme_options']['siteheader'] == 'T') {
         $_REQUEST['imwb_videopress_theme_options']['headertextcol'] = str_replace( '#', '', $_REQUEST['imwb_videopress_theme_options']['headertextcol'] );
         $color = preg_replace('/[^0-9a-fA-F]/', '', $_REQUEST['imwb_videopress_theme_options']['headertextcol']);
         set_theme_mod('header_textcolor', $color);
         set_theme_mod( 'header_image', 'remove-header' );
         remove_theme_mod( 'header_image_data' );
      }
      else {
         set_theme_mod( 'header_textcolor', 'blank' );
      }
      unset($_REQUEST['imwb_videopress_theme_options']['headertextcol']);

      update_option('blogname', wp_unslash($_REQUEST['imwb_videopress_theme_options']['blogname'])  );
      unset($_REQUEST['imwb_videopress_theme_options']['blogname']);

      update_option('blogdescription', $_REQUEST['imwb_videopress_theme_options']['blogdescription']  );
      unset($_REQUEST['imwb_videopress_theme_options']['blogdescription']);

      update_option('imwb_videopress_theme_options', $updatedOptions);
   }
}
?>
